        LIST

        NOLIST

pas

;==========================================================================
;
;       Verify Processor
;
;==========================================================================
        IFNDEF __18F02
           MESSG "Processor-header file mismatch.  Verify selected processor."
        ENDIF

;==========================================================================
;       18Fxxx Family        EQUates
;==========================================================================

;==========================================================================

;==========================================================================
;       16Cxxx/17Cxxx Substitutions
;==========================================================================

  #define DDRA  TRISA          ; PIC17Cxxx SFR substitution
  #define DDRB  TRISB          ; PIC17Cxxx SFR substitution
  #define DDRC  TRISC          ; PIC17Cxxx SFR substitution
  #define DDRD  TRISD          ; PIC17Cxxx SFR substitution
  #define DDRE  TRISE          ; PIC17Cxxx SFR substitution



;==========================================================================
;
;       Register Definitions
;
;==========================================================================

;----- Register Files -----------------------------------------------------
TOSU             EQU  H'0FFF'
TOSH             EQU  H'0FFE'
TOSL             EQU  H'0FFD'
STKPTR           EQU  H'0FFC'
PCLATU           EQU  H'0FFB'
PCLATH           EQU  H'0FFA'

PCL              EQU  H'0FF9'
TBLPTRU          EQU  H'0FF8'
TBLPTRH          EQU  H'0FF7'
TBLPTRL          EQU  H'0FF6'
TABLAT           EQU  H'0FF5'
PRODH            EQU  H'0FF4'
PRODL            EQU  H'0FF3'

INTCON           EQU  H'0FF2'
PCON             EQU  H'0FF1'

INDF             EQU  H'0FEF'
POSTINC0         EQU  H'0FEE'
POSTDEC0         EQU  H'0FED'
PREINC0          EQU  H'0FEC'
PLUSW0           EQU  H'0FEB'
FSR0H            EQU  H'0FEA'
FSR0L            EQU  H'0FE9'
WREG             EQU  H'0FE8'

INDF1            EQU  H'0FE7'
POSTINC1         EQU  H'0FE6'
POSTDEC1         EQU  H'0FE5'
PREINC1          EQU  H'0FE4'
PLUSW1           EQU  H'0FE3'
FSR1H            EQU  H'0FE2'
FSR1L            EQU  H'0FE1'
BSR              EQU  H'0FE0'

INDF2            EQU  H'0FDF'
POSTINC2         EQU  H'0FDE'
POSTDEC2         EQU  H'0FDD'
PREINC2          EQU  H'0FDC'
PLUSW2           EQU  H'0FDB'
FSR2H            EQU  H'0FDA'
FSR2L            EQU  H'0FD9'
STATUS           EQU  H'0FD8'
;//---------------------timer0---------------
T0CON            EQU  H'0FD7'
PR0              EQU  H'0FD6'
TMR0             EQU  H'0FD5'
PWM0DUTY         EQU  H'0FD4'
PWM0CON          EQU  H'0FD3'
RCON             EQU  H'0FD2'

;//---------------------timer1---------------
TMR1H            EQU  H'0FD1'
TMR1L            EQU  H'0FD0'
T1CON0           EQU  H'0FCF'
T1CON1           EQU  H'0FCE'

;//---------------------timer2---------------
TMR2L            EQU  H'0FCD'
TMR2H            EQU  H'0FCC'
PR2L             EQU  H'0FCB'
PR2H             EQU  H'0FCA'
T2CON            EQU  H'0FC9'

;//---------------------CCP---------------
CCPR1H           EQU  H'0FC8'
CCPR1L           EQU  H'0FC7'
CCPR1LH          EQU  H'0FC6'
PMX              EQU  H'0FC5'
PXC              EQU  H'0FC4'
DTC              EQU  H'0FC3'
POLS             EQU  H'0FC2'
PME              EQU  H'0FC1'

CCPCON           EQU  H'0FBF'
PWM1CON0         EQU  H'0FBE'
PWM1CON1         EQU  H'0FBD'
;//---------------------timer3---------------
T3CON            EQU  H'0FBC'
TMR3H            EQU  H'0FBB'
TMR3L            EQU  H'0FBA'
PR3L             EQU  H'0FB9'
PR3H             EQU  H'0FB8'

;//---------------------PWM---------------
PWM5H            EQU  H'0FB7'
PWM5L            EQU  H'0FB6'
PWM4H            EQU  H'0FB5'
PWM4L            EQU  H'0FB4'
PWM3H            EQU  H'0FB3'
PWM3L            EQU  H'0FB2'
PWM2H            EQU  H'0FB1'
PWM2L            EQU  H'0FB0'

PWM2CON0         EQU  H'0FAF'
PWM2CON1         EQU  H'0FAE'
PWM2CON2         EQU  H'0FAD'
PWM2CON3         EQU  H'0FAC'

;//---------------------ADC---------------
ADCMP0H          EQU  H'0FAB'
ADCMP1H          EQU  H'0FAA'
ADCMP01L         EQU  H'0FA9'
ADRESH           EQU  H'0FA8'
ADRESL           EQU  H'0FA7'

ADCON0           EQU  H'0FA6'
ADCON1           EQU  H'0FA5'
ADCON2           EQU  H'0FA4'

;//-----------------INTERRUPT-------------
IPR1             EQU  H'0FA3'
PIR1             EQU  H'0FA2'
PIE1             EQU  H'0FA1'

IPR2             EQU  H'0FA0'
PIR2             EQU  H'0F9F'
PIE2             EQU  H'0F9E'

IPR3             EQU  H'0F9D'
PIR3             EQU  H'0F9C'
PIE3             EQU  H'0F9B'

;//-----------------GPIO-------------
SMTC             EQU  H'0F9A'
SMTB             EQU  H'0F99'
SMTA             EQU  H'0F98'

PCOD             EQU  H'0F96'
PBOD             EQU  H'0F95'
PAOD             EQU  H'0F94'

TRISC            EQU  H'0F92'
TRISB            EQU  H'0F91'
TRISA            EQU  H'0F90'

PCPD             EQU  H'0F8E'
PBPD             EQU  H'0F8D'
PAPD             EQU  H'0F8C'

PINC             EQU  H'0F8A'
PINB             EQU  H'0F89'
PINA             EQU  H'0F88'

PCPU             EQU  H'0F86'
PBPU             EQU  H'0F85'
PAPU             EQU  H'0F84'

PORTC            EQU  H'0F82'
PORTB            EQU  H'0F81'
PORTA            EQU  H'0F80'

;//------------------OP---------------
OP0CON0          EQU  H'0F7F'
OP0CON1          EQU  H'0F7E'
OP0CON2          EQU  H'0F7D'
OP1CON0          EQU  H'0F7C'
OP1CON1          EQU  H'0F7B'
OP1CON2          EQU  H'0F7A'
OPCON            EQU  H'0F79'
;//------------------CMP---------------
CMP0CON          EQU  H'0F78'
CMP1CON          EQU  H'0F77'
CMPCON           EQU  H'0F76'
;//------------------DAC---------------
DAC0CON          EQU  H'0F75'
DAC1CON          EQU  H'0F74'
DACCON           EQU  H'0F73'

FVRCON           EQU  H'0F72'

LCDCON0          EQU  H'0F71'
LCDCON1          EQU  H'0F70'
LCDCON2          EQU  H'0F6F'
LCDCON3          EQU  H'0F6E'

BUCON	         EQU  H'0F6D'

IAPTRIG          EQU  H'0F6C'
IAPTCTRL         EQU  H'0F6B'
IAPADDRH         EQU  H'0F6A'
IAPADDRL         EQU  H'0F69'
IAPDATH          EQU  H'0F68'
IAPDATL          EQU  H'0F67'
IAPWAIT          EQU  H'0F66'

SMCR             EQU  H'0F65'
OSCCON           EQU  H'0F64'
CLKCFG1          EQU  H'0F63'
CLKCFG2          EQU  H'0F62'
SIGCON           EQU  H'0F61'
PAINTMASK        EQU  H'0F60'
PBINTMASK        EQU  H'0F5F'
PCINTMASK        EQU  H'0F5E'

EEDAT        	 EQU  H'0F5C'
EEADR		 	 EQU  H'0F5B'
EECON1		 	 EQU  H'0F5A'
EECON2           EQU  H'0F59'
WDTCON			 EQU  H'0F58'
OP0CON3			 EQU  H'0F57'
OP1C0N3          EQU  H'0F56'
CURCON           EQU  H'0F55'

ANASEL0  		 EQU  H'0F54'
ANASEL1          EQU  H'0F53'
ANASEL2          EQU  H'0F52'

SPBRG    		 EQU  H'0F51'
RCREG            EQU  H'0F50'
TXREG            EQU  H'0F4F'
TXSTA   		 EQU  H'0F4E'
RCSTA            EQU  H'0F4D'
UARTCON          EQU  H'0F4C'

I2CACKDLY		 EQU  H'0F4B'
I2CTX		 	 EQU  H'0F4A'
I2CRC            EQU  H'0F49'
I2CADD0			 EQU  H'0F48'
I2CADD1			 EQU  H'0F47'
I2CADDMASK       EQU  H'0F46'
I2CSTAT          EQU  H'0F45'
I2CCON0  		 EQU  H'0F44'
I2CCON1          EQU  H'0F43'
I2CIE            EQU  H'0F42'
I2CIF   		 EQU  H'0F41'
I2CIP            EQU  H'0F40'



;----- STKPTR Bits --------------------------------------------------------
STKFUL          EQU  H'0007'
STKUNF          EQU  H'0006'
SP4             EQU  H'0004'
SP3             EQU  H'0003'
SP2             EQU  H'0002'
SP1             EQU  H'0001'
SP0             EQU  H'0000'

;----- INTCON Bits --------------------------------------------------------
GIE             EQU  H'0007'
GIEH            EQU  H'0007'
PEIE            EQU  H'0006'
GIEL            EQU  H'0006'
;----- RCON Bits --------------------------------------------------------
IPEN            EQU  H'0007'
LVDST           EQU  H'0005'
RI              EQU  H'0004'
TO              EQU  H'0003'
PD              EQU  H'0002'
POR             EQU  H'0001'
BOR             EQU  H'0000'
;----- WDTCON Bits --------------------------------------------------------
WDTEN            EQU  H'0007'
;----- STATUS Bits --------------------------------------------------------
N               EQU  H'0004'
OV              EQU  H'0003'
Z               EQU  H'0002'
DC              EQU  H'0001'
C               EQU  H'0000'

;----- T0CON Bits ---------------------------------------------------------
T0OUT           EQU  H'0007'
T0CS1           EQU  H'0006'
T0CS0           EQU  H'0005'
T0SE            EQU  H'0004'
PSA             EQU  H'0003'
PS2             EQU  H'0002'
PS1             EQU  H'0001'
PS0             EQU  H'0000'

;----- PWM0CON Bits ---------------------------------------------------------
POLS03          EQU  H'0007'
POLS02          EQU  H'0006'
POLS01          EQU  H'0005'
POLS00          EQU  H'0004'
PWM03EN         EQU  H'0003'
PWM02EN         EQU  H'0002'
PWM01EN         EQU  H'0001'
PWM00EN         EQU  H'0000'

;----- T1CON0 Bits ---------------------------------------------------------
T1CK1           EQU  H'0007'
T1CK0           EQU  H'0006'
T1CKPS1         EQU  H'0005'
T1CKPS0         EQU  H'0004'
T1SE            EQU  H'0003'
T1SYNC          EQU  H'0002'
TMR1CS0         EQU  H'0001'
TMR1ON          EQU  H'0000'
;----- T1CON1 Bits ---------------------------------------------------------
INT2EDGE        EQU  H'0007'
INT1EDGE        EQU  H'0006'
INT0EDGE        EQU  H'0005'
T1EDGE          EQU  H'0004'
T1CH1           EQU  H'0003'
T1CH0           EQU  H'0002'
T1M1            EQU  H'0001'
T1M0            EQU  H'0000'

;----- T2CON0 Bits ---------------------------------------------------------
PWM2CAE         EQU  H'0007'
T2OUTPS3        EQU  H'0006'
T2OUTPS2        EQU  H'0005'
T2OUTPS1        EQU  H'0004'
T2OUTPS0        EQU  H'0003'
TMR2ON          EQU  H'0002'
T2CKPS1         EQU  H'0001'
T2CKPS0         EQU  H'0000'

;----- PMS  Bits -------------------------------------------------------
DMISTK2        EQU  H'0007'
PWMH           EQU  H'0006'
PMS21          EQU  H'0005'
PMS20          EQU  H'0004'
PMS11          EQU  H'0003'
PMS10          EQU  H'0002'
PMS01          EQU  H'0001'
PMS00          EQU  H'0000'

;----- PXC  Bits -------------------------------------------------------
T3PWMEN          EQU  H'0007'
PWM14SEL         EQU  H'0006'
PXC21            EQU  H'0005'
PXC20            EQU  H'0004'
PXC11            EQU  H'0003'
PXC10            EQU  H'0002'
PXC01            EQU  H'0001'
PXC00            EQU  H'0000'
;----- DTC  Bits -------------------------------------------------------
DTCKS1          EQU  H'0007'
DTCKS0          EQU  H'0006'
DTEN            EQU  H'0005'
DTD4            EQU  H'0004'
DTD3            EQU  H'0003'
DTD2            EQU  H'0002'
DTD1            EQU  H'0001'
DTD0            EQU  H'0000'
;----- POLS   Bits -------------------------------------------------------
PT2MODE          EQU  H'0006'
POLS2_1          EQU  H'0005'
POLS2_0          EQU  H'0004'
POLS1_1          EQU  H'0003'
POLS1_0          EQU  H'0002'
POLS0_1          EQU  H'0001'
POLS0_0          EQU  H'0000'
;----- PME  Bits -------------------------------------------------------
PT1MODE          EQU  H'0007'
PT0MODE          EQU  H'0006'
PWM2EN1          EQU  H'0005'
PWM2EN0          EQU  H'0004'
PWM1EN1          EQU  H'0003'
PWM1EN0          EQU  H'0002'
PWM0EN1          EQU  H'0001'
PWM0EN0          EQU  H'0000'


;----- CCPCON   Bits -------------------------------------------------------
CCP1CH3         EQU  H'0007'
CCP1CH2         EQU  H'0006'
CCP1CH1         EQU  H'0005'
CCP1CH0         EQU  H'0004'
CCP1M3          EQU  H'0003'
CCP1M2          EQU  H'0002'
CCP1M1          EQU  H'0001'
CCP1M0          EQU  H'0000'
;----- PWM1CON0 Bits -------------------------------------------------------
PWMEN           EQU  H'0007'
CMPFLT          EQU  H'0006'
ASTART          EQU  H'0005'
ACLOSE          EQU  H'0004'
OPFLT           EQU  H'0003'
IOFLT           EQU  H'0002'
PWM10ADPOS      EQU  H'0001'
PWM10ADEN       EQU  H'0000'
;----- T3CON Bits -------------------------------------------------------
PWM3CAE         EQU  H'0007'
T3OUTPS3        EQU  H'0006'
T3OUTPS2        EQU  H'0005'
T3OUTPS1        EQU  H'0004'
T3OUTPS0        EQU  H'0003'
TMR3ON          EQU  H'0002'
T3CKPS1         EQU  H'0001'
T3CKPS0         EQU  H'0000'
;----- PWM2CON0 Bits -------------------------------------------------------
PWM2EN          EQU  H'0000'
PWM3EN          EQU  H'0001'
PWM4EN          EQU  H'0002'
PWM5EN          EQU  H'0003'
PWM5OEN         EQU  H'0004'
PWM4OEN         EQU  H'0005'
PWM3OEN         EQU  H'0006'
PWM2OEN         EQU  H'0007'

;----- PWM2CON1 Bits -------------------------------------------------------
POLS5           EQU  H'0003'
POLS4           EQU  H'0002'
POLS3           EQU  H'0001'
POLS2           EQU  H'0000'

;----- PWM2CON3 Bits -------------------------------------------------------
P5CS1          EQU  H'0007'
P5CS0          EQU  H'0006'
P4CS1          EQU  H'0005'
P4CS0          EQU  H'0004'
P3CS1          EQU  H'0003'
P3CS0          EQU  H'0002'
P2CS1          EQU  H'0001'
P2CS0          EQU  H'0000'

;----- ADCON0 Bits --------------------------------------------------------
ADFM           EQU  H'0007'
ADCMPMODE      EQU  H'0006'
CHS3           EQU  H'0005'
CHS2           EQU  H'0004'
CHS1           EQU  H'0003'
CHS0           EQU  H'0002'
DONG           EQU  H'0001'
GO             EQU  H'0001'
ADON           EQU  H'0000'

;----- ADCON1 Bits --------------------------------------------------------
ADVREF1         EQU  H'0007'
ADVREF0         EQU  H'0006'
ACQT2           EQU  H'0005'
ACQT1           EQU  H'0004'
ACQT0           EQU  H'0003'
ADCS2           EQU  H'0002'
ADCS1           EQU  H'0001'
ADCS0           EQU  H'0000'
;----- ADCON2 Bits --------------------------------------------------------
ACQT6         EQU  H'0007'
ACQT5         EQU  H'0006'
ACQT4         EQU  H'0005'
ACQT3         EQU  H'0004'
ACN1          EQU  H'0003'
ACN0          EQU  H'0002'
ACFVR         EQU  H'0001'
ACEN          EQU  H'0000'
;----- PCON Bits --------------------------------------------------------
PB0ST         EQU  H'0006'
LVDM1         EQU  H'0005'
LVDM0         EQU  H'0004'
LVT3          EQU  H'0003'
LVT2          EQU  H'0002'
LVT1          EQU  H'0001'
LVT0          EQU  H'0000'

;----- IPR1 Bits --------------------------------------------------------------
RCIP	          EQU  H'0006'
TXIP	          EQU  H'0005'
CCPIP             EQU  H'0004'
TMR3IP            EQU  H'0003'
TMR2IP            EQU  H'0002'
TMR1IP            EQU  H'0001'
TMR0IP            EQU  H'0000'

;----- PIR1 Bits --------------------------------------------------------------
RCIF	          EQU  H'0006'
TXIF	          EQU  H'0005'
CCPIF             EQU  H'0004'
TMR3IF            EQU  H'0003'
TMR2IF            EQU  H'0002'
TMR1IF            EQU  H'0001'
TMR0IF            EQU  H'0000'
;----- PIE1 Bits ---------------------------------------------------------------
RCIE	          EQU  H'0006'
TXIE	          EQU  H'0005'
CCPIE             EQU  H'0004'
TMR3IE            EQU  H'0003'
TMR2IE            EQU  H'0002'
TMR1IE            EQU  H'0001'
TMR0IE            EQU  H'0000'

;----- IPR2 Bits --------------------------------------------------------------
PCIP             EQU  H'0007'
PBIP             EQU  H'0006'
PAIP             EQU  H'0005'
INT2IP           EQU  H'0004'
INT1IP           EQU  H'0003'
INT0IP           EQU  H'0002'
CMP1IP           EQU  H'0001'
CMP0IP           EQU  H'0000'

;----- PIR2 Bits --------------------------------------------------------------
PCIF             EQU  H'0007'
PBIF             EQU  H'0006'
PAIF             EQU  H'0005'
INT2IF           EQU  H'0004'
INT1IF           EQU  H'0003'
INT0IF           EQU  H'0002'
CMP1IF           EQU  H'0001'
CMP0IF           EQU  H'0000'

;----- PIE2 Bits ---------------------------------------------------------------
PCIE             EQU  H'0007'
PBIE             EQU  H'0006'
PAIE             EQU  H'0005'
INT2IE           EQU  H'0004'
INT1IE           EQU  H'0003'
INT0IE           EQU  H'0002'
CMP1IE           EQU  H'0001'
CMP0IE           EQU  H'0000'

;----- IPR3 Bits ----------------------------------------------------------------
ADCMP1IP        EQU  H'0007'
ADCMP0IP        EQU  H'0006'
ADIP            EQU  H'0005'
OP1IP           EQU  H'0004'
OP0IP           EQU  H'0003'
EEIP            EQU  H'0002'
OSFIP           EQU  H'0001'
LVDIP           EQU  H'0000'

;----- PIR3 Bits ----------------------------------------------------------------
ADCMP1IF        EQU  H'0007'
ADCMP0IF        EQU  H'0006'
ADIF            EQU  H'0005'
OP1IF           EQU  H'0004'
OP0IF           EQU  H'0003'
EEIF            EQU  H'0002'
OSFIF           EQU  H'0001'
LVDIF           EQU  H'0000'

;----- PIE3 Bits -----------------------------------------------------------------
ADCMP1IE        EQU  H'0007'
ADCMP0IE        EQU  H'0006'
ADIE            EQU  H'0005'
OP1IE           EQU  H'0004'
OP0IE           EQU  H'0003'
EEIE            EQU  H'0002'
OSFIE           EQU  H'0001'
LVDIE           EQU  H'0000'



;----- SMTC  Bits -------------------------------------------------------------
PC5SMT          EQU  H'0005'
PC4SMT          EQU  H'0004'
PC3SMT          EQU  H'0003'
PC2SMT          EQU  H'0002'
PC1SMT          EQU  H'0001'
PC0SMT          EQU  H'0000'
;----- SMTB  Bits ---------------------------------------------------------
PB5SMT          EQU  H'0005'
PB4SMT          EQU  H'0004'
PB3SMT          EQU  H'0003'
PB2SMT          EQU  H'0002'
PB1SMT          EQU  H'0001'
PB0SMT          EQU  H'0000'
;----- SMTA  Bits ---------------------------------------------------------
PA5SMT          EQU  H'0005'
PA4SMT          EQU  H'0004'
PA3SMT          EQU  H'0003'
PA2SMT          EQU  H'0002'
PA1SMT          EQU  H'0001'
PA0SMT          EQU  H'0000'

;----- PCOD Bits -------------------------------------------------------
PC5OD           EQU  H'0005'
PC4OD           EQU  H'0004'
PC3OD           EQU  H'0003'
PC2OD           EQU  H'0002'
PC1OD           EQU  H'0001'
PC0OD           EQU  H'0000'
;----- PBOD Bits ----------------------------------------------------------
PB5OD           EQU  H'0005'
PB4OD           EQU  H'0004'
PB3OD           EQU  H'0003'
PB2OD           EQU  H'0002'
PB1OD           EQU  H'0001'
PB0OD           EQU  H'0000'
;----- PAOD Bits ------------------------------------------------------------
PA5OD           EQU  H'0005'
PA4OD           EQU  H'0004'
PA3OD           EQU  H'0003'
PA2OD           EQU  H'0002'
PA1OD           EQU  H'0001'
PA0OD           EQU  H'0000'
;----- TRISC Bits ---------------------------------------------------------------
TRISC5          EQU  H'0005'
TRISC4          EQU  H'0004'
TRISC3          EQU  H'0003'
TRISC2          EQU  H'0002'
TRISC1          EQU  H'0001'
TRISC0          EQU  H'0000'
;----- TRISB Bits ----------------------------------------------------------------
TRISB5          EQU  H'0005'
TRISB4          EQU  H'0004'
TRISB3          EQU  H'0003'
TRISB2          EQU  H'0002'
TRISB1          EQU  H'0001'
TRISB0          EQU  H'0000'
;----- TRISA Bits -----------------------------------------------------------------
TRISA5          EQU  H'0005'
TRISA4          EQU  H'0004'
TRISA3          EQU  H'0003'
TRISA2          EQU  H'0002'
TRISA1          EQU  H'0001'
TRISA0          EQU  H'0000'

;----- PCPD Bits -------------------------------------------------------------------
PC5PD           EQU  H'0005'
PC4PD           EQU  H'0004'
PC3PD           EQU  H'0003'
PC2PD           EQU  H'0002'
PC1PD           EQU  H'0001'
PC0PD           EQU  H'0000'

;----- PBPD Bits -------------------------------------------------------------------
PB5PD           EQU  H'0005'
PB4PD           EQU  H'0004'
PB3PD           EQU  H'0003'
PB2PD           EQU  H'0002'
PB1PD           EQU  H'0001'
PB0PD           EQU  H'0000'

;----- PAPD Bits -------------------------------------------------------------------
PA5PD           EQU  H'0005'
PA4PD           EQU  H'0004'
PA3PD           EQU  H'0003'
PA2PD           EQU  H'0002'
PA1PD           EQU  H'0001'
PA0PD           EQU  H'0000'


;----- PCPU Bits -------------------------------------------------------------------
PC5PU           EQU  H'0005'
PC4PU           EQU  H'0004'
PC3PU           EQU  H'0003'
PC2PU           EQU  H'0002'
PC1PU           EQU  H'0001'
PC0PU           EQU  H'0000'
;----- PBPU Bits -------------------------------------------------------------------
PB5PU           EQU  H'0005'
PB4PU           EQU  H'0004'
PB3PU           EQU  H'0003'
PB2PU           EQU  H'0002'
PB1PU           EQU  H'0001'
PB0PU           EQU  H'0000'
;----- PAPU Bits -------------------------------------------------------------------
PA5PU           EQU  H'0005'
PA4PU           EQU  H'0004'
PA3PU           EQU  H'0003'
PA2PU           EQU  H'0002'
PA1PU           EQU  H'0001'
PA0PU           EQU  H'0000'

;----- PORTC Bits -------------------------------------------------------------------
PC5             EQU  H'0005'
PC4             EQU  H'0004'
PC3             EQU  H'0003'
PC2             EQU  H'0002'
PC1             EQU  H'0001'
PC0             EQU  H'0000'
;----- PORTB Bits -------------------------------------------------------------------
PB5             EQU  H'0005'
PB4             EQU  H'0004'
PB3             EQU  H'0003'
PB2             EQU  H'0002'
PB1             EQU  H'0001'
PB0             EQU  H'0000'

;----- PORTA Bits -------------------------------------------------------------------
PA5             EQU  H'0005'
PA4             EQU  H'0004'
PA3             EQU  H'0003'
PA2             EQU  H'0002'
PA1             EQU  H'0001'
PA0             EQU  H'0000'

;//---------------------------------OP0&OP1--------------------------------------------------


;----- OP0CON0  Bits -------------------------------------------------------------------
OP0ON         EQU  H'0007'
EX0	          EQU  H'0006'
A1NS0         EQU  H'0005'
PCH02         EQU  H'0004'
PCH01         EQU  H'0003'
PCH00         EQU  H'0002'
NCH01         EQU  H'0001'
NCH00         EQU  H'0000'

;----- OP0CON1  Bits -------------------------------------------------------------------
OP0OUT	        EQU  H'0007'
OUT1EN0	        EQU  H'0006'
AN_AVSS0        EQU  H'0005'
A1O2N0	        EQU  H'0004'
PGAEN0	        EQU  H'0003'
OP0POS	        EQU  H'0002'
CMPMODE0        EQU  H'0001'
OUT0EN0	        EQU  H'0000'

;----- OP0CON2  Bits -------------------------------------------------------------------
FILTER04         EQU  H'0007'
FILTER03         EQU  H'0006'
FILTER02         EQU  H'0005'
FILTER01         EQU  H'0004'
FILTER000        EQU  H'0003'
OP0A2DEN         EQU  H'0002'
OP0PGA1          EQU  H'0001'
OP0PGA0	         EQU  H'0000'
;----- OP0CON3  Bits -------------------------------------------------------------------
OP0_SW0 	         EQU  H'0006'
OP0_OFFSETEN         EQU  H'0005'
OP0_OFFSET4          EQU  H'0004'
OP0_OFFSET3          EQU  H'0003'
OP0_OFFSET2          EQU  H'0002'
OP0_OFFSET1          EQU  H'0001'
OP0_OFFSET0          EQU  H'0000'
;----- OP1CON0  Bits -------------------------------------------------------------------
OP1ON        EQU  H'0007'
EX1	         EQU  H'0006'
A1NS1        EQU  H'0005'
PCH12        EQU  H'0004'
PCH11        EQU  H'0003'
PCH10        EQU  H'0002'
NCH11        EQU  H'0001'
NCH10        EQU  H'0000'

;----- OP1CON1  Bits -------------------------------------------------------------------
OP1OUT          EQU  H'0007'
OUT1EN1         EQU  H'0006'
AN_AVSS1        EQU  H'0005'
AIO2N1          EQU  H'0004'
PGAEN1          EQU  H'0003'
OP1POS          EQU  H'0002'
CMP1MODE        EQU  H'0001'
OUT0EN1         EQU  H'0000'

;----- OP1CON2  Bits -------------------------------------------------------------------
FILTER14        EQU  H'0007'
FILTER13        EQU  H'0006'
FILTER12        EQU  H'0005'
FILTER11        EQU  H'0004'
FILTER10        EQU  H'0003'
OP1A2DEN        EQU  H'0002'
OP1PGA1         EQU  H'0001'
OP1PGA0         EQU  H'0000'
;--------------------------------------OP1 & OP0-------------------------------------------
OP1CSEL3	    EQU  H'0007'
OP1CSEL2	    EQU  H'0006'
OP1CSEL1 		EQU  H'0005'
OP1CSEL0		EQU  H'0004'
OP0CSEL3	    EQU  H'0003'
OP0CSEL2	    EQU  H'0002'
OP0CSEL1 		EQU  H'0001'
OP0CSEL0		EQU  H'0000'
;--------------------------------------OP1-------------------------------------------
OP1_SW1 	   EQU  H'0006'
OP1_OFFSETEN   EQU  H'0005'
OP1_OFFSET4    EQU  H'0004'
OP1_OFFSET3    EQU  H'0003'
OP1_OFFSET2    EQU  H'0002'
OP1_OFFSET1    EQU  H'0001'
OP1_OFFSET0    EQU  H'0000'
;---------------------------------CMP0&CMP1-------------------------------------------

;------CMP0CON Bits -------------------------------------------------------------------
CMP0EN          EQU  H'0007'
CMP0OUT         EQU  H'0006'
CMP0POS         EQU  H'0005'
CMP0PCH2        EQU  H'0004'
CMP0PCH1        EQU  H'0003'
CMP0PCH0        EQU  H'0002'
CMP0NCH1        EQU  H'0001'
CMP0NCH0        EQU  H'0000'

;-----CMP1CON Bits -------------------------------------------------------------------
CMP1EN          EQU  H'0007'
CMP1OUT         EQU  H'0006'
CMP1POS         EQU  H'0005'
CMP1PCH2        EQU  H'0004'
CMP1PCH1        EQU  H'0003'
CMP1PCH0        EQU  H'0002'
CMP1NCH1        EQU  H'0001'
CMP1NCH0        EQU  H'0000'

;-----CMPCON Bits -------------------------------------------------------------------

CMPFILTER3       EQU  H'0007'
CMPFILTER2       EQU  H'0006'
CMPFILTER1       EQU  H'0005'
CMPFILTER0       EQU  H'0004'
C1OUT1EN         EQU  H'0003'
C1OUT0EN         EQU  H'0002'
C0OUT1EN         EQU  H'0001'
C0OUT0EN         EQU  H'0000'

;-----DACCON Bits -------------------------------------------------------------------
DAC1VREF1           EQU  H'0003'
DAC1VREF0           EQU  H'0002'
DAC0VREF1           EQU  H'0001'
DAC0VREF0           EQU  H'0000'
;-----DAC0CON Bits -------------------------------------------------------------------
DAC0EN          EQU  H'0006'

;-----DAC1CON Bits -------------------------------------------------------------------
DAC1EN          EQU  H'0006'

;------- FVRCON  Bits ------------------------------------------------------------
FVROUTEN        EQU  H'0007'
FVRPGA          EQU  H'0006'
FVREN           EQU  H'0005'
FVR_SEL4        EQU  H'0004'
FVR_SEL3        EQU  H'0003'
FVR_SEL2        EQU  H'0002'
FVR_SEL1        EQU  H'0001'
FVR_SEL0        EQU  H'0000'

;//---------------------------------------LCD-----------------------------

;------- LCDCON0  Bits ------------------------------------------------------------
LCD_EN          EQU  H'0000'

;------- LCDCON1  Bits ------------------------------------------------------------
COM7EN          EQU  H'0007'
COM6EN          EQU  H'0006'
COM5EN          EQU  H'0005'
COM4EN          EQU  H'0004'
COM3EN          EQU  H'0003'
COM2EN          EQU  H'0002'
COM1EN          EQU  H'0001'
COM0EN          EQU  H'0000'

;------- LCDCON2  Bits ------------------------------------------------------------
LCDCSEL1        EQU  H'0007'
LCDCSEL0        EQU  H'0006'
COM9EN          EQU  H'0001'
COM8EN          EQU  H'0000'

;------- BUCON  Bits ------------------------------------------------------------
BUOUTEN        EQU  H'0005'
BUEN           EQU  H'0004'
BUSEL2         EQU  H'0002'
BUSEL1         EQU  H'0001'
BUSEL0         EQU  H'0000'

;-------IAPCTRL  Bits ------------------------------------------------------------
ERR            EQU  H'0003'
LOCK           EQU  H'0002'
ER             EQU  H'0001'
PG             EQU  H'0000'

;-------SMCR  Bits ------------------------------------------------------------
SM2            EQU  H'0003'
SM1            EQU  H'0002'
SM0            EQU  H'0001'
SE             EQU  H'0000'
;-------OSCCON  Bits ------------------------------------------------------------
FINTOSC2       EQU  H'0006'
FINTOSC1       EQU  H'0005'
FINTOSC0       EQU  H'0004'
LIRC2MEN       EQU  H'0003'
;------- CLKCFG1 Bits ------------------------------------------------------------------
OPCLKEN           EQU  H'0007'
UARTCLKEN         EQU  H'0006'
CKOE1             EQU  H'0005'
CKOE0             EQU  H'0004'
OSCF1             EQU  H'0003'
OSCF0             EQU  H'0002'
OSCM1             EQU  H'0001'
OSCM0             EQU  H'0000'

;------- CLKCFG2 Bits ------------------------------------------------------------------
CMPCLKEN        EQU  H'0007'
DACCLKEN        EQU  H'0006'
ADCCLKEN        EQU  H'0005'
CCPCLKEN        EQU  H'0004'
T3CLKEN         EQU  H'0003'
T2CLKEN         EQU  H'0002'
T1CLKEN         EQU  H'0001'
T0CLKEN         EQU  H'0000'

;------- SIGCON Bits ------------------------------------------------------------------
I2CCLKEN        EQU  H'0003'
ICE_TMREN       EQU  H'0002'
UART_MUX        EQU  H'0001'
SIGS            EQU  H'0000'

;------- PAINTMASK Bits ------------------------------------------------------------
PA5MSK          EQU  H'0005'
PA4MSK          EQU  H'0004'
PA3MSK          EQU  H'0003'
PA2MSK          EQU  H'0002'
PA1MSK          EQU  H'0001'
PA0MSK          EQU  H'0000'

;------- PBINTMASK Bits ------------------------------------------------------------
PB5MSK          EQU  H'0005'
PB4MSK          EQU  H'0004'
PB3MSK          EQU  H'0003'
PB2MSK          EQU  H'0002'
PB1MSK          EQU  H'0001'
PB0MSK          EQU  H'0000'

;------- PCINTMASK Bits ------------------------------------------------------------
PC5MSK          EQU  H'0005'
PC4MSK          EQU  H'0004'
PC3MSK          EQU  H'0003'
PC2MSK          EQU  H'0002'
PC1MSK          EQU  H'0001'
PC0MSK          EQU  H'0000'

;------- EECON1 Bits ------------------------------------------------------------
WERR            EQU  H'0003'
WREN            EQU  H'0002'
WR              EQU  H'0001'
RD              EQU  H'0000'

;------- ANASEL0 Bits ------------------------------------------------------------
PA5AEN          EQU  H'0005'
PA4AEN          EQU  H'0004'
PA3AEN          EQU  H'0003'
PA2AEN          EQU  H'0002'
PA1AEN          EQU  H'0001'
PA0AEN          EQU  H'0000'

;------- ANASEL1 Bits ------------------------------------------------------------
PB5AEN          EQU  H'0005'
PB4AEN          EQU  H'0004'
PB3AEN          EQU  H'0003'
PB2AEN          EQU  H'0002'
PB1AEN          EQU  H'0001'
PB0AEN          EQU  H'0000'

;------- ANASEL2 Bits ------------------------------------------------------------
PC5AEN          EQU  H'0005'
PC4AEN          EQU  H'0004'
PC3AEN          EQU  H'0003'
PC2AEN          EQU  H'0002'
PC1AEN          EQU  H'0001'
PC0AEN          EQU  H'0000'

;------- TXSTA Bits ------------------------------------------------------------
CSRC			EQU  H'0007'
TX9		   		EQU  H'0006'
TXEN			EQU  H'0005'
SYNC			EQU  H'0004'
TX_PARTY		EQU  H'0003'
BRGH			EQU  H'0002'
TMPT			EQU  H'0001'
TX9D			EQU  H'0000'
;------- RCSTA Bits ------------------------------------------------------------
SPEN			EQU  H'0007'
RX9				EQU  H'0006'
SREN			EQU  H'0005'
CREN       		EQU  H'0004'
BGRM			EQU  H'0003'
FERR			EQU  H'0002'
OERR			EQU  H'0001'
RX9D			EQU  H'0000'
;------- UARTCON Bits ------------------------------------------------------------
INVMODE		    EQU  H'0007'
PARITY	        EQU  H'0006'
ODD_EVEN		EQU  H'0005'
BOUD_CLK		EQU  H'0004'
HALF_DUPLEX	    EQU  H'0003'
DLSB    		EQU  H'0002'
STOP_BIT1		EQU  H'0001'
STOP_BIT0		EQU  H'0000'
;------- I2CACKDLY Bits ------------------------------------------------------------
ACKDLYON        EQU  H'0007'
ACKDLY6        	EQU  H'0006'
ACKDLY5    		EQU  H'0005'
ACKDLY4    		EQU  H'0004'
ACKDLY3         EQU  H'0003'
ACKDLY2    		EQU  H'0002'
ACKDLY1    		EQU  H'0001'
ACKDLY0    		EQU  H'0000'
;------- I2CSTAT  Bits ------------------------------------------------------------
SMP1            EQU  H'0007'
SMP0        	EQU  H'0006'
A     		    EQU  H'0005'
D    		    EQU  H'0005'
P       		EQU  H'0004'
S               EQU  H'0003'
R        		EQU  H'0002'
W      		    EQU  H'0002'
BPRX    		EQU  H'0001'
BPTX    		EQU  H'0000'

;------- I2CADD0 Bits ------------------------------------------------------------
ADD0EN    		EQU  H'0007'

;------- I2CADD1 Bits ------------------------------------------------------------
ADD1EN    		EQU  H'0007'

;------- I2CCON0 Bits ------------------------------------------------------------
WCOL    		EQU  H'0007'
I2COV    		EQU  H'0006'
I2CEN           EQU  H'0005'
;------- I2CCON1 Bits ------------------------------------------------------------
GCEN            EQU  H'0007'
ACKSTAT        	EQU  H'0006'
ACKGET 		    EQU  H'0005'
ACKEN      		EQU  H'0004'

;------- I2CIE Bits ------------------------------------------------------------
I2C_FLOATIE     EQU  H'0004'
I2C_STOPIE      EQU  H'0003'
I2C_STARTIE     EQU  H'0002'
I2C_TXIE        EQU  H'0001'
I2C_RCIE        EQU  H'0000'
;------- I2CIF Bits ------------------------------------------------------------
I2C_FLOATIF     EQU  H'0004'
I2C_STOPIF      EQU  H'0003'
I2C_STARTIF     EQU  H'0002'
I2C_TXIF        EQU  H'0001'
I2C_RCIF        EQU  H'0000'

;------- I2CIP Bits ------------------------------------------------------------
I2C_FLOATIP     EQU  H'0004'
I2C_STOPIP      EQU  H'0003'
I2C_STARTIP     EQU  H'0002'
I2C_TXIP        EQU  H'0001'
I2C_RCIP        EQU  H'0000'

;==========================================================================
;
;       RAM Definition
;
;==========================================================================

    __MAXRAM H'FFF'
    __BADRAM H'200'-H'F7F'
    __BADRAM H'F85'-H'F88'
    __BADRAM H'F8E'-H'F91'
    __BADRAM H'F97'-H'F9C'
    __BADRAM H'FA3'-H'FA5'
    __BADRAM H'FAA'
    __BADRAM H'FB4'-H'FB9'


;==========================================================================
;
;   IMPORTANT: For the XAD16810 devices, the __CONFIG directive has been
;              superseded by the CONFIG directive.  The following settings
;              are available for this device.
;
;
;==========================================================================
;==========================================================================
;
;       Configuration Bits
;
;     Data Sheet    Include File                  Address
;     CONFIG1L    = Configuration Byte 1L         300000h
;     CONFIG1H    = Configuration Byte 1H         300001h
;     CONFIG2L    = Configuration Byte 2L         300002h
;     CONFIG2H    = Configuration Byte 2H         300003h
;     CONFIG3L    = Configuration Byte 3L         300004h
;     CONFIG3H    = Configuration Byte 3H         300005h
;     CONFIG4L    = Configuration Byte 4L         300006h
;     CONFIG4H    = Configuration Byte 4H         300007h
;     CONFIG5L    = Configuration Byte 5L         300008h
;     CONFIG5H    = Configuration Byte 5H         300009h
;     CONFIG6L    = Configuration Byte 6L         30000ah
;     CONFIG6H    = Configuration Byte 6H         30000bh
;     CONFIG7L    = Configuration Byte 7L         30000ch
;     CONFIG7H    = Configuration Byte 7H         30000dh
;
;==========================================================================

;Configuration Byte 1L Options
_LVT20V_1L          EQU  H'F0'
_LVT21V_1L          EQU  H'F1'
_LVT22V_1L          EQU  H'F2'
_LVT24V_1L          EQU  H'F3'
_LVT26V_1L          EQU  H'F4'
_LVT27V_1L          EQU  H'F5'
_LVT29V_1L          EQU  H'F6'
_LVT30V_1L          EQU  H'F7'
_LVT31V_1L          EQU  H'F8'
_LVT33V_1L          EQU  H'F9'
_LVT36V_1L          EQU  H'FA'
_LVT37V_1L          EQU  H'FB'
_LVT38V_1L          EQU  H'FC'
_LVT41V_1L          EQU  H'FD'
_LVT42V_1L          EQU  H'FE'
_LVT43V_1L          EQU  H'FF'

_LVREN_ON_1L        EQU  H'FF'
_LVREN_OFF_1L       EQU  H'EF'

_FINTOSC_DIV1_1L    EQU  H'FF'
_FINTOSC_DIV2_1L    EQU  H'DF'
_FINTOSC_DIV4_1L    EQU  H'BF'
_FINTOSC_DIV8_1L    EQU  H'9F'
_FINTOSC_DIV16_1L   EQU  H'5F'


;Configuration Byte 2L Options
_STV_ON_2L          EQU  H'FF'   ; Stack overflow reset enable
_STV_OFF_2L         EQU  H'FE'

_RSEL_LOW_2L        EQU  H'FF'   ; 30K,30K
_RSEL_HIGH_2L       EQU  H'FD'   ; 100K,300K

_RESETE_ON_2L       EQU  H'FF'
_RESETE_OFF_2L      EQU  H'FB'

_CBP_ON_2L          EQU  H'FF'
_CBP_OFF_2L         EQU  H'F7'

_CKSUM_OFF_2L       EQU  H'EF'
_CKSUM_ON_2L        EQU  H'FF'

_IDIS_OFF_2L        EQU  H'DF'
_IDIS_ON_2L         EQU  H'FF'

_CRYHEN_ON_2L       EQU  H'FF'     ; high-speed external crystal enable
_CRYHEN_OFF_2L      EQU  H'BF'     ; high-speed external crystal disable

_CRYLEN_ON_2L       EQU  H'FF'     ; low-speed external crystal enable
_CRYLEN_OFF_2L      EQU  H'7F'     ; low-speed external crystal disable

_FLASH_CP0_ON_2H    EQU  H'FF'	  ; ENABLE
_FLASH_CP0_OFF_2H   EQU  H'FE'	  ; DISABLE

_FLASH_CP1_ON_2H    EQU  H'FF'	  ; ENABLE
_FLASH_CP1_OFF_2H   EQU  H'FD'	  ; DISABLE

_FLASH_CP2_ON_2H    EQU  H'FF'	  ; ENABLE
_FLASH_CP2_OFF_2H   EQU  H'FB'	  ; DISABLE

_FLASH_CP3_ON_2H    EQU  H'FF'	  ; ENABLE
_FLASH_CP3_OFF_2H   EQU  H'F7'	  ; DISABLE

_DBG_ON_2H          EQU  H'FF'	  ; ENABLE
_DBG_OFF_2H         EQU  H'EF'	  ; DISABLE


;Configuration Byte 3L Options

_TWDT_111_3L     EQU H'FF'	 ; 1:128   8.5S
_TWDT_110_3L     EQU H'FE'	 ; 1:64    4.31S
_TWDT_101_3L     EQU H'FD'	 ; 1:32    1.92S
_TWDT_100_3L     EQU H'FC'	 ; 1:16    1.1S
_TWDT_011_3L     EQU H'FB'	 ; 1:8     653ms
_TWDT_010_3L     EQU H'FA'	 ; 1:4     391ms
_TWDT_001_3L     EQU H'F9'	 ; 1:2     260ms
_TWDT_000_3L     EQU H'F8'	 ; 1:1     128.4ms

_WDTEN_ON_3L        EQU  H'FF'    ; WDT enabled
_WDTEN_OFF_3L       EQU  H'F7'    ; WDT disabled


_FCPU_4T_3L         EQU  H'FF'    ; 4T PER INSTRUCTION
_FCPU_2T_3L         EQU  H'EF'    ; 2T PER INSTRUCITON

_PSUT_1_3L          EQU  H'1F'    ; 2.26ms
_PSUT_2_3L          EQU  H'3F'    ; 2.26ms
_PSUT_4_3L          EQU  H'5F'    ; 2.26ms
_PSUT_8_3L          EQU  H'7F'    ; 2.26ms
_PSUT_16_3L         EQU  H'9F'    ; 79.2ms
_PSUT_32_3L         EQU  H'BF'    ; 309.6ms
_PSUT_64_3L         EQU  H'DF'    ; 11.9ms
_PSUT_128_3L        EQU  H'FF'    ; 2.4ms

;Configuration Byte 4L Options
_ADCSP_OFF_4L       EQU  H'FE'    ; ADC low speed
_ADCSP_ON_4L        EQU  H'FF'    ; ADC high speed

_IESO_ON_4L         EQU  H'FF'    ;使能双速启动模式
_IESO_OFF_4L        EQU  H'FD'    ;禁止双速启动模式

_FCMEN_ON_4L        EQU  H'FF'    ;使能系统时钟失效监测
_FCMEN_OFF_4L       EQU  H'FB'    ;禁止系统时钟失效监测

_OSCM_HIRC_16M_4L   EQU H'FF'
_OSCM_LIRC_1M_4L    EQU H'BF'
_OSCM_EHRC_16M_4L   EQU H'7F'
_OSCM_LIRC_32K_4L   EQU H'3F'

_Reserved           EQU H'FF'
; To use the Configuration Bits, place the following lines in your source code
;  in the following format, and change the configuration value to the desired
;  setting (such as CP_OFF to CP_ON).  These are currently commented out here
;  and each __CONFIG line should have the preceding semicolon removed when
;  pasted into your source code.

;  The following is a assignment of address values for all of the configuration
;  registers for the purpose of table reads
_CONFIG1L         EQU    H'300000'
_CONFIG1H         EQU    H'300001'
_CONFIG2L         EQU    H'300002'
_CONFIG2H         EQU    H'300003'
_CONFIG3L         EQU    H'300004'
_CONFIG3H         EQU    H'300005'
_CONFIG4L         EQU    H'300006'
_CONFIG4H         EQU    H'300007'
;_CONFIG5L         EQU    H'300008'
;_CONFIG5H         EQU    H'300009'
;_CONFIG6L        EQU    H'30000A'
;_CONFIG6H        EQU    H'30000B'
;_CONFIG7L        EQU    H'30000C'
;_CONFIG7H        EQU    H'30000D'
;_DEVID1          EQU    H'3FFFFE'
;_DEVID2          EQU    H'3FFFFF'
;_IDLOC0          EQU    H'200000'
;_IDLOC1          EQU    H'200001'
;_IDLOC2          EQU    H'200002'
;_IDLOC3          EQU    H'200003'
;_IDLOC4          EQU    H'200004'
;_IDLOC5          EQU    H'200005'
;_IDLOC6          EQU    H'200006'
;_IDLOC7          EQU    H'200007'

;Program Configuration Register 1H
;		__CONFIG    _CONFIG1H, _OSCS_OFF_1H & _RCIO_OSC_1H

;Program Configuration Register 2L
;		__CONFIG    _CONFIG2L, _BOR_ON_2L & _BORV_20_2L & _PWRT_OFF_2L

;Program Configuration Register 2H
;		__CONFIG    _CONFIG2H, _WDT_ON_2H & _WDTPS_128_2H

;Program Configuration Register 3H
;		__CONFIG    _CONFIG3H, _CCP2MX_ON_3H

;Program Configuration Register 4L
;		__CONFIG    _CONFIG4L, _STVR_ON_4L & _LVP_OFF_4L & _DEBUG_OFF_4L

;Program Configuration Register 5L
;		__CONFIG    _CONFIG5L, _CP0_OFF_5L & _CP1_OFF_5L & _CP2_OFF_5L & _CP3_OFF_5L

;Program Configuration Register 5H
;		__CONFIG    _CONFIG5H, _CPB_ON_5H & _CPD_OFF_5H

;Program Configuration Register 6L
;		__CONFIG    _CONFIG6L, _WRT0_OFF_6L & _WRT1_OFF_6L & _WRT2_OFF_6L & _WRT3_OFF_6L

;Program Configuration Register 6H
;		__CONFIG    _CONFIG6H, _WRTC_OFF_6H & _WRTB_OFF_6H & _WRTD_OFF_6H

;Program Configuration Register 7L
;		__CONFIG    _CONFIG7L, _EBTR0_OFF_7L & _EBTR1_OFF_7L & _EBTR2_OFF_7L & _EBTR3_OFF_7L

;Program Configuration Register 7H
;		__CONFIG    _CONFIG7H, _EBTRB_OFF_7H

;ID Locations Register 0
;		__IDLOCS    _IDLOC0, <expression>

;ID Locations Register 1
;		__IDLOCS    _IDLOC1, <expression>

;ID Locations Register 2
;		__IDLOCS    _IDLOC2, <expression>

;ID Locations Register 3
;		__IDLOCS    _IDLOC3, <expression>

;ID Locations Register 4
;		__IDLOCS    _IDLOC4, <expression>

;ID Locations Register 5
;		__IDLOCS    _IDLOC5, <expression>

;ID Locations Register 6
;		__IDLOCS    _IDLOC6, <expression>

;ID Locations Register 7
;		__IDLOCS    _IDLOC7, <expression>

;Device ID registers hold device ID and revision number and can only be read
;Device ID Register 1
;               DEV2, DEV1, DEV0, REV4, REV3, REV2, REV1, REV0
;Device ID Register 2
;               DEV10, DEV9, DEV8, DEV7, DEV6, DEV5, DEV4, DEV3

        LIST
