;=====================================================================
; Device      : AD18F02
; Author      : AD Application Team
; Version     : V0.0.1
; Date        : 20211016
; Description : 定时器0 定时10ms，中断里面PB0翻转，主循环PA0翻转
;=====================================================================
 include "AD18F02.inc"

;----- CONFIG Options Begin--------------------------------------------------
 __CONFIG  _CONFIG1L , _FINTOSC_DIV1_1L     & _LVREN_OFF_1L     & _LVT24V_1L
 __CONFIG  _CONFIG1H , _Reserved
 __CONFIG  _CONFIG2L ,_CRYLEN_OFF_2L        & _CRYHEN_OFF_2L    & _IDIS_OFF_2L       & _CKSUM_OFF_2L      & _CBP_OFF_2L     & _RESETE_OFF_2L & _RSEL_LOW_2L & _STV_ON_2L
 __CONFIG  _CONFIG2H , _DBG_ON_2H          & _FLASH_CP3_OFF_2H & _FLASH_CP2_OFF_2H  & _FLASH_CP1_OFF_2H  &_FLASH_CP0_OFF_2H
 __CONFIG  _CONFIG3L , _PSUT_32_3L          & _FCPU_4T_3L       & _WDTEN_OFF_3L      & _TWDT_011_3L
 __CONFIG  _CONFIG3H , _Reserved
 __CONFIG  _CONFIG4L , _OSCM_HIRC_16M_4L    & _FCMEN_OFF_4L     & _IESO_OFF_4L       & _ADCSP_ON_4L
 __CONFIG  _CONFIG4H , _Reserved
;=====================================================================
;-------------------------- ROM AREAS --------------------------------
;=====================================================================
	ORG		0000H			;复位地址
	GOTO	MAIN

	ORG		0008H			;硬件中断地址，高优先级
	GOTO    HINTERR

	ORG		0018H			;硬件中断地址，低优先级
	GOTO    LINTERR
;=====================================================================
;---------------- INTERRUPT PROGRAMME BEGINNING ----------------------
;=====================================================================

HINTERR BTFSC PIR1, TMR0IF
     BTFSS PIE1, TMR0IE
     GOTO REGRESO
     BCF PIR1, TMR0IF
     MOVLW 0x01
     XORWF PORTB,0x01 ; PB0翻转
     goto  INT_EXIT
LINTERR


     goto  INT_EXIT

INT_EXIT
REGRESO RETFIE

;=====================================================================
;---------------- DELAY PROGRAMME BEGINNING ----------------------
;=====================================================================
DELAY   MOVLW    0x82        ;延时子程序

        MOVWF    N           ;给N赋值130

LOOP    DECFSZ N,1  ;N-1送回N并判结果＝0？是！跳出循环

        GOTO     LOOP        ;否！循环回去

        RETURN               ;返回


;=====================================================================
;------------------ MAIN PROGRAMME BEGINNING -------------------------
;=====================================================================
MAIN MOVLW 0X01
     MOVLB 0x0F
     BSF CLKCFG2,T0CLKEN

     MOVLW 0X9C
     MOVWF PR0

     MOVLW 0X07
     MOVWF T0CON

     CLRF TMR0

     CLRF  TRISB

     MOVLW B'00000000' ;PORTA全设为输出
     MOVWF TRISA

     BSF IPR1,TMR0IP
     BCF PIR1,TMR0IF
     BSF PIE1,TMR0IE

	BSF RCON,IPEN
     ;使能中断优先级
     BSF INTCON,GIEH
     ;使能高优先级全局中断

;主循环------------------------------------
CYCLE
     NOP
     MOVLW 0x01
     XORWF PORTA,0x01 ; PA0翻转
     CALL DELAY
     GOTO CYCLE


 END
