/*******************************************************************************
* Device      : AD18F02
* Author      : XAD Application Team
* Version     : V0.0.1
* Date        : 20201201
* Description : 串口相关函数声明及头文件
********************************************************************************/

#ifndef _USART_H_
#define _USART_H_

/********************************INCLUDES*************************************/
#include "common.h"


/*******************************MACROS_USR************************************/
//波特率设置
#define BAUD 19200
//时钟
#define FOSC 16000000L
//1-- 9位数据 0-- 8位数据
#define NINE 0     /* Use 9bit communication? FALSE=8bit */

//BGRH置1时 波特率设置
#define DIVIDER ((int)(FOSC/(16UL * BAUD)))
#define HIGH_SPEED 1

/////////////////////通信方式设置//////////////////////////
#if NINE == 1
#define NINE_BITS 0x40	//9位发送
#else
#define NINE_BITS 0	//8位发送
#endif

///////////////////////BGRH设置///////////////////////////
#if HIGH_SPEED == 1
#define SPEED 0x4	//BGRH置1
#else
#define SPEED 0
#endif

///////////////////////相关IO设置///////////////////////////
#define UART_SW 1

#if UART_SW == 1
#define RX_PIN TRISB1
#define TX_PIN TRISB0
//UART_AUX=0; //切换IO 至 A0 A1
#else
#define RX_PIN TRISA0
#define TX_PIN TRISA1
#endif

void Com_Init();

void putch(unsigned char);
unsigned char getch(void);
unsigned char getche(void);

#endif
