/*******************************************************************************
* Device      : AD18F02x
* Author      : XAD Application Team
* Version     : V0.0.1
* Date        : 20201201
* Description : 系统外设驱动函数头文件
********************************************************************************/

#ifndef __PERIPH_H__
#define __PERIPH_H__

#include <stdio.h>
#include "AD18F02x.h"
#include "Periph.h"
#include "Common.h"

/**********************************CMP0****************************************/

#define CMP0P_FVROUT            0    //比较器正端输入FVROUT
#define CMP0P_OP0OUT            1    //比较器正端输入OP0OUT
#define CMP0P_PA3               2    //比较器正端输入PA3
#define CMP0P_PB0               3    //比较器正端输入PB0
#define CMP0P_BUOUT             4    //比较器正端输入BUOUT
#define CMP0P_DAC0OUT           5    //比较器正端输入DAC0OUT
#define CMP0P_DAC1OUT           6    //比较器正端输入DAC1OUT
#define CMP0P_OP1OUT            7    //比较器正端输入OP1OUT

#define CMP0N_0V5               0    //比较器负端输入0.5V
#define CMP0N_DAC0OUT           1    //比较器负端输入DAC0OUT
#define CMP0N_PA2               2    //比较器负端输入PA2
#define CMP0N_PB1               3    //比较器负端输入PB1

/**********************************CMP1****************************************/

#define CMP1P_FVROUT            0    //比较器正端输入FVROUT
#define CMP1P_OP0OUT            1    //比较器正端输入OP0OUT
#define CMP1P_PA3               2    //比较器正端输入PA3
#define CMP1P_PB0               3    //比较器正端输入PB0
#define CMP1P_BUOUT             4    //比较器正端输入BUOUT
#define CMP1P_DAC0OUT           5    //比较器正端输入DAC0OUT
#define CMP1P_DAC1OUT           6    //比较器正端输入DAC1OUT
#define CMP1P_OP1OUT            7    //比较器正端输入OP1OUT

#define CMP1N_0V3               0    //比较器负端输入0.3V
#define CMP1N_DAC1OUT           1    //比较器负端输入DAC1OUT
#define CMP1N_PA2               2    //比较器负端输入PA2
#define CMP1N_PB1               3    //比较器负端输入PB1



//Cmp_p-CMP0正端输入通道选择，Cmp_p-CMP0负端输入通道选择；
//mode-1~使能CMP0，0~关闭CMP0;
void CMP0_Config(unsigned char Cmp_p,unsigned char Cmp_n,unsigned char mode);
//Cmp_p-CMP1正端输入通道选择，Cmp_p-CMP1负端输入通道选择；
//mode-1~使能CMP1，0~关闭CMP1;
void CMP1_Config(unsigned char Cmp_p,unsigned char Cmp_n,unsigned char mode);
//Cmp0-CMP0输出IO选择; 0~不输出,1~PA2,2~PB2,3~PA2/PB2同时输出
//Cmp1-CMP1输出IO选择; 0~不输出,1~PA1,2~PB2,3~PA1/PB2同时输出
void Cmpout_Config(unsigned char Cmp0,unsigned char Cmp1);


#endif
