/*******************************************************************************
* Device      : AD18F02
* Author      : XAD Application Team
* Version     : V0.0.1
* Date        : 20201201
* Description : 系统外设驱动函数头文件
********************************************************************************/


#ifndef __PERIPH_H__
#define __PERIPH_H__

#include <stdio.h>
#include "AD18F02x.h"
#include "Periph.h"
#include "Common.h"

//ch:BUFFER输入通道选择;0-DAC0,1-DAC1,2-VDD/4,3-NTC,4-OP0,5-OP1,6-PA2,7-PA0
//OutEn:1-使能从PC5输出,0-禁止从IO输出
//mode-1~使能BUFFER，0~关闭BUFFER;
void BUF_Config(unsigned char ch,unsigned char OutEn,unsigned char mode);

//DacMode：DAC抽头选择	0-Vdac = (n+9)*Vref/40, 1-Vdac = (n+1)*Vref/32,
//						2：Vdac = (n+9)*Vref/32,3：Vdac = (n+1)*Vref/24,
//Data：输出电压值选择，具体值根据上述公式计算
//state：1-使能DAC 0-关闭DAC
void DAC0_Config(unsigned char DacMode,unsigned char Data,unsigned char state);
#endif
