/*******************************************************************************
* Device      : AD18F02x
* Author      : XAD Application Team
* Version     : V0.0.1
* Date        : 20201201
* Description : 系统外设驱动函数
********************************************************************************/

/********************************INCLUDES*************************************/
#include "Periph.h"

/*******************************************************************************
* Description    : FVR_Config
* Input          : ch:FVR电压位选择;
*				   OutEn:1-使能从PC4输出FVR值,0-禁止从IO输出
*				   mode-1~使能FVR，0~关闭FVR;
* Return         : None.
* Note           : None.
*******************************************************************************/

void FVR_Config(unsigned char ch,unsigned char OutEn,unsigned char mode)
{
	if(mode == 1)
	{
		FVRCON = 0 << 6;		//输出电压是否放大选择，1-放大1倍
		FVRCON |= ch;			//FVR电压选择
		FVRCON |= OutEn << 7;	//FVR通过I/O输出（PC4）选择，1-使能
		FVRCON |= 1 << 5;		//使能FVR
	}
	else
	{
		FVRCON &= ~(1<<5);		//关闭FVR
	}
}


