#include "AD18F02x.h"	//系统头文件
#include "i2c.h"


/*******************************************************************************
* Description    : i2c初始化函数
* Input          : None.
* Return         : None.
* Note           : 需注AD18F02x22无此功能
*******************************************************************************/

void I2C_Init(void)
{


	PAPU &= 0XF3;	//PA2/3上拉打开
//	PAOD |= 0X0C;	//PA2/3开漏

	TRISA|= 0X0C;	//PA2/3输入
//	PORTA=0X00;

	I2CCLKEN=1;

	I2CADDR0 = ADDR0|0X80;	//设置并使能ADDR0
	I2CADDR1 = ADDR1|0X80;	////设置并使能ADDR1   slave-从器件地址（7bit或另一10bit 地址高4bit）

//	I2CADDMASK =0x80|MASK;  	//地址掩码的使能，并设置
//	I2CACKDLY = 0X83;	//使能ACK延时，延时时间为48*Fosc*8

	I2CCON0  = 0X20;	//使能并将SDA和SCL正确配置为输入输出 ,必须发START信号发送与接收的地址才可以匹配

	I2C_STARTIF=0;
	I2C_RCIF=0;
	I2C_STOPIF=0;

	I2C_RCIE=1;	//接收中断使能
	I2C_RCIP=1;	//接收中断高优先级
//	I2C_TXIE=1;	//从机发送中断
	I2C_STARTIE=1;	//开始信号中断使能
	I2C_STARTIP=1;	//开始信号中断高优先级
//	I2C_FLOATIE=1;	//总线低电平时间超过 32ms
	I2C_STOPIE=1;	//停止信号中断使能
	I2C_STOPIP=1;	//停止信号中断高优先级
}

/*******************************************************************************
* Description    : 读取一字节I2C数据
* Input          : None.
* Return         : None.
* Note           : None.
*******************************************************************************/
unsigned char I2C_Getch(unsigned char ack)
{
	while(I2C_RCIF==0);	//接收中断标志
	I2C_RCIF = 0;
	if(ack)        //set next byte ack signal
		ACKEN=1;		//在SDA和SCL引脚上发起应答，并发送 ACKDT 数据位 硬件自动清零
	else
		ACKEN=0;
	return I2CRC;	//返回IIC_CRC
}

/*******************************************************************************
* Description    : 写一字节I2C数据
* Input          : None.
* Return         : None.
* Note           : None.
*******************************************************************************/
unsigned char I2C_Putch(unsigned char ch)
{
	I2CTX = ch;	//ch放入发送缓冲区
	while(I2C_TXIF==0);	//等待发送完成
	I2C_TXIF = 0;
	return ACKSTAT;  //返回主器件的是否应答
}
