/*******************************************************************************
* Device      : AD18F02x
* Author      : XAD Application Team
* Version     : V0.0.1
* Date        : 20201201
* Description : 系统外设驱动函数
********************************************************************************/

/********************************INCLUDES*************************************/
#include "Periph.h"

/*******************************************************************************
* Description    : PC_Int
* Input          : 	io：中断I/O通道选择（0~5）
					mode：选择是否开启I/O中断，1-打开中断，0-关闭中断
* Return         : None.
* Note           : None.
*******************************************************************************/
void PC_Int(unsigned char io,unsigned char mode)
{
	if(mode)
	{
		PCINTMASK|=1<<io;		//选择产生中断的I/O
		TRISC|=1<<io;			//产生中断的I/O设置为输入模式
		PCPU&=~(1<<io);			//开启产生中断的I/O的上拉电阻
		PCIP=1;
		PCIF=0;
		PCIE=1;
	}
	else
	{
		PCIE=1;
		PCINTMASK&=~(1<<io);
	}
}


