/*******************************************************************************
* Device      : AD18F02x
* Author      : XAD Application Team
* Version     : V0.0.1
* Date        : 20201201
* Description : 系统外设驱动函数
********************************************************************************/

/********************************INCLUDES*************************************/
#include "Periph.h"

/*******************************************************************************
* Description    : LVD_config
* Input          : 	Lvd_Mode：电压比较中断形式选择
								0:禁止电压比较器
								1:VCC低于阀值电压产生中断
								2:VCC高于阀值电压产生中断
								3:VCC高于阀值电压产生中断，且强制PB0输出PB0ST值
					Lvd_vol：VCC电压阈值选择
* Return         : None.
* Note           : None.
*******************************************************************************/
void LVD_config(unsigned char Lvd_Mode,unsigned char Lvd_vol)
{
	if(Lvd_Mode)
	{
		PCON = Lvd_Mode<< 4; 	//写入比较中断形式到PCON[5:4]
		PCON |= Lvd_vol;        //写入中断电压阀值

		LVDIP=1;
		LVDIF=0;
		LVDIE=1;				//开LVD中断
	}
	else
	{
		PCON&=0XCF;				//禁止电压比较器
		LVDIE=0;
	}
}


