#include "AD18F02x.h"
#include <stdio.h>
#include "common.h"

/*******************************************************************************
* Description    : GPIO_Init
* Input          : None.
* Return         : None.
* Note           : 所有IO初始化
*******************************************************************************/

void GPIO_Init(void)
{
	TRISA = 0X00;   //PA输出模式
	TRISB = 0X00;   //PB输出模式
	TRISC = 0X00;   //PC输出模式

	PORTA = 0X00;	//PORTA输出0
	PORTB = 0X00;	//PORTB输出0
	PORTC = 0X00;	//PORTC输出0

	PAPD = 0XFF;    //关闭PA下拉
	PAPU = 0XFF;    //关闭PA上拉
	PBPD = 0XFF;    //关闭PB下拉
	PBPU = 0XFF;    //关闭PB上拉
	PCPD = 0XFF;    //关闭PC下拉
	PCPU = 0XFF;    //关闭PC上拉

	PAOD = 0X00;    //关PA开漏输出
	PBOD = 0X00;    //关PB开漏输出
	PCOD = 0X00;    //关PC开漏输出

	ANASEL0 = 0X00; //关PA模拟量通道
	ANASEL1 = 0X00; //关PB模拟量通道
	ANASEL2 = 0X00; //关PC模拟量通道
}


/*******************************************************************************
* Description    : OP0_Init
* Input          : None.
* Return         : None.
* Note           : OP0的buffer模式
*******************************************************************************/
void OP0_Init(void)
{
	OP0_Offset_test();  //OP0自动校准

	OP0CON0 = 0X80;    //OP0使能，使能正负端交换，正端输入PA3
	OP0CON1 = 0X11;    //运放连接为buffer，使能从IO输出(PA1,PB4)
	OP0CON2 = 0X00;    //滤波值为0
	OPCON = 0X00;      //偏置电流设置为00
}
/*******************************************************************************
* Description    : OP1_Init
* Input          : None.
* Return         : None.
* Note           : OP1的buffer模式
*******************************************************************************/
void OP1_Init(void)
{
	OP1_Offset_test();  //OP1自动校准

	OP1CON0 = 0X80;    //OP1使能，使能正负端交换，正端输入PA0
	OP1CON1 = 0X11;    //运放连接为buffer，使能从IO输出(PB1,PB3)
	OP1CON2 = 0X00;    //滤波值为0
	OPCON = 0X00;      //偏置电流设置
}


