/*******************************************************************************
* Device      : AD18F02x
* Author      : XAD Application Team
* Version     : V0.0.1
* Date        : 20201201
* Description : 系统外设驱动函数头文件
********************************************************************************/


#ifndef __PERIPH_H__
#define __PERIPH_H__

#include <stdio.h>
#include "AD18F02x.h"
#include "Periph.h"
#include "Common.h"

//P_ch：运放P端输入选择
		//0-PC3
		//1-FVROUT
		//2-PC4
		//3-OP1OUT
		//4-BUOUT
		//5-DAC0OUT
		//6-DAC1OUT
		//7-1.0V(BGR)
//N_ch：运放N端输入选择
		//0-PA3
		//1-FVROUT
		//2-PA2
		//3-DAC0OUT
//Amp:内部放大倍数选择
		//0-2倍，1-10倍，2-20倍，3-100倍
//mode：1-使能运放，0-关闭运放
void OP0_Config(unsigned char P_ch,unsigned char N_ch,unsigned char Amp,unsigned char mode);

//P_ch：运放P端输入选择
		//0-PC5
		//1-FVROUT
		//2-PB5
		//3-OP0OUT
		//4-BUOUT
		//5-DAC0OUT
		//6-DAC1OUT
		//7-1.0V
//N_ch：运放N端输入选择
		//0-PA0
		//1-FVROUT
		//2-PB0
		//3-DAC1OUT
//Amp:内部放大倍数选择
		//0-2倍，1-10倍，2-20倍，3-100倍
//mode：1-使能运放，0-关闭运放

//Offset：校准值输入
void OP1_Offset(unsigned char Offset);

#endif
