#include "AD18F02x.h"
#include <stdio.h>
#include "common.h"

/*******************************************************************************
// ----Function: GPIO_Init
// --Parameters:
// -----Returns: None
//---------Note:所有IO初始化
*******************************************************************************/

void GPIO_Init(void)
{
	TRISA = 0X00;   //PA输出模式
	TRISB = 0X00;   //PB输出模式
	TRISC = 0X00;   //PC输出模式

	PORTA = 0X00;	//PORTA输出0
	PORTB = 0X00;	//PORTB输出0
	PORTC = 0X00;	//PORTC输出0

	PAPD = 0XFF;    //关闭PA下拉
	PAPU = 0XFF;    //关闭PA上拉
	PBPD = 0XFF;    //关闭PB下拉
	PBPU = 0XFF;    //关闭PB上拉
	PCPD = 0XFF;    //关闭PC下拉
	PCPU = 0XFF;    //关闭PC上拉

	PAOD = 0X00;    //关PA开漏输出
	PBOD = 0X00;    //关PB开漏输出
	PCOD = 0X00;    //关PC开漏输出

	ANASEL0 = 0X00; //关PA模拟量通道
	ANASEL1 = 0X00; //关PB模拟量通道
	ANASEL2 = 0X00; //关PC模拟量通道
}

/*******************************************************************************
// ----Function: Pwm_Init
// --Parameters:
// -----Returns: None
//---------Note:PWM周期t
				Fcpu作为TMR0时钟：
					4T  PWM周期t=PR0*定时器0分频系数*4T/16MHz
					2T  PWM周期t=PR0*定时器0分频系数*2T/16MHz
				其它时钟源作为TMR0时钟：
					 PWM周期t=PR0*定时器0分频系数/osc
				  占空比 = PWMDUTY/PR0
*******************************************************************************/

void Pwm_Init(void)
{
	T0CLKEN  = 1;     //开TMR0时钟
	PR0      = 0X63;  //PWM 周期t=100*4分频*4T/16MHz=100us（10kHz）
	T0CON    = 0X01;  //TMR0时钟为FCPU，使能TMR0时钟，4分频
	PWM0DUTY = 0X19;  //占空比 = PWM0DUTY/PR0 = 25/100 = 25%
	PWM0CON  = 0XAF;  //使能PWM从PB0,PB1,PB4,PA0四个I/O输出,PB0/4取反
}
