#include "AD18F02x.h"
#include <stdio.h>
#include "common.h"

/*******************************************************************************
// ----Function: GPIO_Init
// --Parameters:
// -----Returns: None
//---------Note:所有IO初始化
*******************************************************************************/

void GPIO_Init(void)
{
	TRISA = 0X00;   //PA输出模式
	TRISB = 0X00;   //PB输出模式
	TRISC = 0X00;   //PC输出模式

	PORTA = 0X00;	//PORTA输出0
	PORTB = 0X00;	//PORTB输出0
	PORTC = 0X00;	//PORTC输出0

	PAPD = 0XFF;    //关闭PA下拉
	PAPU = 0XFF;    //关闭PA上拉
	PBPD = 0XFF;    //关闭PB下拉
	PBPU = 0XFF;    //关闭PB上拉
	PCPD = 0XFF;    //关闭PC下拉
	PCPU = 0XFF;    //关闭PC上拉

	PAOD = 0X00;    //关PA开漏输出
	PBOD = 0X00;    //关PB开漏输出
	PCOD = 0X00;    //关PC开漏输出

	ANASEL0 = 0X00; //关PA模拟量通道
	ANASEL1 = 0X00; //关PB模拟量通道
	ANASEL2 = 0X00; //关PC模拟量通道
}

/*******************************************************************************
// ----Function: Timer0_Init
// --Parameters:
// -----Returns: None
//---------Note: 定时器0初始化，定时10ms
				Fcpu作为TMR0时钟：
					4T  t=PR0*定时器0分频系数*4T/16MHz
					2T  t=PR0*定时器0分频系数*2T/16MHz
				其它时钟源作为TMR0时钟：
					t=PR0*定时器0分频系数/osc
*******************************************************************************/

void timer0_Init(void)
{
	T0CLKEN = 1;    //开T0时钟
	PR0 = 0X9C; 	//t=156*256*4T/16MHz=9984us
	T0CON = 0X07;   //TMR0时钟为Fcpu，使能TMR0时钟，256分频

	TMR0IF = 0;     //清中断标志
	TMR0IE = 1;     //开TMR0中断
	TMR0IP = 1;		//高优先级中断

	IPEN = 0;       //禁止中断优先级
	PEIE = 1;       //允许所有外设中断
	GIE = 1;        //开总中断
}

