#include "AD18F02x.h"
#include <stdio.h>
#include "common.h"

/*******************************************************************************
// ----Function: GPIO_Init
// --Parameters:
// -----Returns: None
//---------Note:所有IO初始化
*******************************************************************************/

void GPIO_Init(void)
{
	TRISA = 0X00;   //PA输出模式
	TRISB = 0X00;   //PB输出模式
	TRISC = 0X00;   //PC输出模式

	PORTA = 0X00;	//PORTA输出0
	PORTB = 0X00;	//PORTB输出0
	PORTC = 0X00;	//PORTC输出0

	PAPD = 0XFF;    //关闭PA下拉
	PAPU = 0XFF;    //关闭PA上拉
	PBPD = 0XFF;    //关闭PB下拉
	PBPU = 0XFF;    //关闭PB上拉
	PCPD = 0XFF;    //关闭PC下拉
	PCPU = 0XFF;    //关闭PC上拉

	PAOD = 0X00;    //关PA开漏输出
	PBOD = 0X00;    //关PB开漏输出
	PCOD = 0X00;    //关PC开漏输出

	ANASEL0 = 0X00; //关PA模拟量通道
	ANASEL1 = 0X00; //关PB模拟量通道
	ANASEL2 = 0X00; //关PC模拟量通道
}

/*******************************************************************************
// ----Function: Timer1_Caputure_Init
// --Parameters: channel:捕获通道选择
				 mode:捕获模式选择
// -----Returns: None
//---------Note: 定时器1初始化
*******************************************************************************/
void Timer1_Caputure_Init(uint8_t channel,uint8_t mode)
{
   //对应GPIO设置为输入的模式，关闭上下拉，关闭开漏，关闭模拟通道
   switch(channel)
   {
		case  CAPTURE_CH0:{TRISA0 = 1;PA0PD = 1;PA0PU = 1;PA0OD = 0;PA0AEN = 0;}break;
		case  CAPTURE_CH1:{TRISA1 = 1;PA1PD = 1;PA1PU = 1;PA1OD = 0;PA1AEN = 0;}break;
		case  CAPTURE_CH2:{TRISA2 = 1;PA2PD = 1;PA2PU = 1;PA2OD = 0;PA2AEN = 0;}break;
		case  CAPTURE_CH3:{TRISA3 = 1;PA3PD = 1;PA3PU = 1;PA3OD = 0;PA3AEN = 0;}break;
		case  CAPTURE_CH4:{TRISB0 = 1;PB0PD = 1;PB0PU = 1;PB0OD = 0;PB0AEN = 0;}break;
		case  CAPTURE_CH5:{TRISA1 = 1;PA1PD = 1;PA1PU = 1;PA1OD = 0;PA1AEN = 0;}break;
		case  CAPTURE_CH6:{TRISA1 = 1;PA1PD = 1;PA1PU = 1;PA1OD = 0;PA1AEN = 0;}break;
		case  CAPTURE_CH7:{TRISA1 = 1;PA1PD = 1;PA1PU = 1;PA1OD = 0;PA1AEN = 0;}break;
		case  CAPTURE_CH8:{TRISB0 = 1;PB0PD = 1;PB0PU = 1;PB0OD = 0;PB0AEN = 0;}break;
		case  CAPTURE_CH9:{TRISB1 = 1;PB1PD = 1;PB1PU = 1;PB1OD = 0;PB1AEN = 0;}break;
		case  CAPTURE_CH10:{TRISB2 = 1;PB2PD = 1;PB2PU = 1;PB2OD = 0;PB2AEN = 0;}break;
		case  CAPTURE_CH11:{TRISB3 = 1;PB3PD = 1;PB3PU = 1;PB3OD = 0;PB3AEN = 0;}break;
		case  CAPTURE_CH12:{TRISB4 = 1;PB4PD = 1;PB4PU = 1;PB4OD = 0;PB4AEN = 0;}break;
		case  CAPTURE_CH13:{TRISB5 = 1;PB5PD = 1;PB5PU = 1;PB5OD = 0;PB5AEN = 0;}break;
		case  CAPTURE_CH14:{TRISC2 = 1;PC2PD = 1;PC2PU = 1;PC2OD = 0;PC2AEN = 0;}break;
		case  CAPTURE_CH15:{TRISC3 = 1;PC3PD = 1;PC3PU = 1;PC3OD = 0;PC3AEN = 0;}break;
	    default: break;
   }
	T1CLKEN = 1;    //开T1时钟
	TMR1H  = 0X00;
	TMR1L  = 0X00;
	CCPR1H = 0X00;
	CCPR1L = 0X00;         //初始清0

	CCPCON = channel << 4; //选择通道,（选择的通道需设置成输入）
	CCPCON |= mode;        //选择捕获模式

	T1CON0 = 0X21;         //使能T1,4分频

	printf("\r\n/*** [DEBUG] ***/\r\n");
	printf("CCPCON = 0X%02X !\r\n",CCPCON);
	printf("/***************/\r\n\r\n");


   	CCPIF = 0;
	CCPIE = 1;
	CCPIP = 1;		//高优先级中断

	IPEN = 0;       //禁止中断优先级
	PEIE = 1;       //允许所有外设中断
}




