
#ifndef _COMMON_H_
#define _COMMON_H_


#define	T1EDGE_L    0 		//在下降沿启动计数，上升沿停止计数
#define	T1EDGE_H    1		//在上升沿启动计数，下降沿停止计数

#define	CHANNEL_PA0    0	 	//T1CH0 作为脉宽检测输入信号(PA0)
#define	CHANNEL_PA4    1	 	//T1CH1 作为脉宽检测输入信号(PA4)
#define	CHANNEL_PA5    2	 	//T1CH2 作为脉宽检测输入信号(PA5)
#define	CHANNEL_TMR2CLK 3	    //TMR2CLK 作为脉宽检测输入信号(配置T2CON0<2>=1)

#define	MODE_0         1 	    //脉宽测量模式 0,复位TIMER1从停止位置开始计数
#define	MODE_1         2		//脉宽测量模式 1,复位TIMER1从 0x0000 开始计数

typedef signed   char   int8_t;     //!< Signed 8 bit integer
typedef unsigned char   uint8_t;    //!< Unsigned 8 bit integer

typedef signed   short  int16_t;    //!< Signed 16 bit integer
typedef unsigned short  uint16_t;   //!< Unsigned 16 bit integer

typedef signed   long   int32_t;    //!< Signed 32 bit integer
typedef unsigned long   uint32_t;   //!< Unsigned 32 bit integer

typedef unsigned char   bool;     //!< Boolean data type


void GPIO_Init(void);
void Int_Enable();
//Parameters:mode:测量模式选择
//T1edge:选择计数方式
//channel:输入通道选择
void TIMER1_EDGE_Measure(uint8_t mode,uint8_t T1edge,uint8_t channel);

#endif
