#include "AD18F02x.h"
#include <stdio.h>
#include "common.h"

/*******************************************************************************
// ----Function: GPIO_Init
// --Parameters:
// -----Returns: None
//---------Note:所有IO初始化
*******************************************************************************/

void GPIO_Init(void)
{
	TRISA = 0X00;   //PA输出模式
	TRISB = 0X00;   //PB输出模式
	TRISC = 0X00;   //PC输出模式

	PORTA = 0X00;	//PORTA输出0
	PORTB = 0X00;	//PORTB输出0
	PORTC = 0X00;	//PORTC输出0

	PAPD = 0XFF;    //关闭PA下拉
	PAPU = 0XFF;    //关闭PA上拉
	PBPD = 0XFF;    //关闭PB下拉
	PBPU = 0XFF;    //关闭PB上拉
	PCPD = 0XFF;    //关闭PC下拉
	PCPU = 0XFF;    //关闭PC上拉

	PAOD = 0X00;    //关PA开漏输出
	PBOD = 0X00;    //关PB开漏输出
	PCOD = 0X00;    //关PC开漏输出

	ANASEL0 = 0X00; //关PA模拟量通道
	ANASEL1 = 0X00; //关PB模拟量通道
	ANASEL2 = 0X00; //关PC模拟量通道
}

/*******************************************************************************
// ----Function: Timer1_Init
// --Parameters:
// -----Returns: None
//---------Note: 定时器1初始化，定时10ms
			Fcpu作为TMR1时钟:
			4T	t = (FFFF-TMR)*定时器1分频系数*4T/16MHz
			2T	t = (FFFF-TMR)*定时器1分频系数*2T/16MHz
			其它时钟源作为TMR1时钟:
			t = (FFFF-TMR)*定时器1分频系数/osc
*******************************************************************************/

void timer1_Init(void)
{
	T1CLKEN = 1;     //开T1时钟
	TMR1H = 0XD8;    //t = (65536-55296)*1/1.024MHz = 10ms
	TMR1L = 0X00;
	T1CON1 = 0X00;   //工作在普通模式
	T1CON0 = 0X43;   //T1CK[1:0]作为TMR1时钟,为1.024M（无关2T，4T模式），使能TMR1时钟，不分频

	TMR1IF = 0;      //清中断标志
	TMR1IP = 1;		 //高优先级中断
	TMR1IE = 1;      //开TMR1中断
}

