/*********************************************************************************************
* Device      : AD18F02x
* Author      : XAD Application Team
* Version     : V0.0.1
* Date        : 20201201
* Description : 系统外设驱动函数头文件
*********************************************************************************************/


#ifndef __PERIPH_H__
#define __PERIPH_H__

#include <stdio.h>
#include "AD18F02x.h"
#include "Periph.h"
#include "Common.h"
#include "CommDef.h"


/**********************************************************************************************PWM10_PWM15宏定义设置*/
/**********************************************************************************************PWM10_PWM15宏定义设置*/
/*******************************!!! 以下宏定义在缺省的情况下,均为默认值.***********************PWM10_PWM15宏定义设置*/
/**********************************************************************************************PWM10_PWM15宏定义设置*/
/**********************************************************************************************PWM10_PWM15宏定义设置*/

#define           CCP_PWM            TRUE             //使能CCP模块的三组PWM

/******************************************PWM10_11设置***************************************/
#define           PWM10_11_MODE      PWM_CPMT

//PWM10_11_MODE可选如下四种配置:
//                                   PWM_CPMT         :PWM互补式控制(默认)
//                                   UP_ARM           :非互补式上臂调制
//                                   DW_ARM           :非互补式下臂调制
//                                   SEL_cfg          :由如下定义“PWM10_11_SEL”控制

#define           PWM10_11_SEL       SEL_UP_DW_OFF

//当PWM10_11_MODE配置为SEL_cfg时,PWM10_11_SEL定义有效,可选如下四种配置:
//                                   SEL_UP_DW_OFF    :上/下臂输出都关闭(默认)
//                                   SEL_UP_OFF_DW_ON :上臂输出关闭/下臂输出导通
//                                   SEL_UP_ON_DW_OFF :上臂输出导通/下臂输出关闭
//                                   SEL_UPDW_Mw_OFF  :上/下臂输出都关闭（防止上/下臂同时导通）

#define           CCP_PWM10          TRUE             //PWM10输出控制,TRUE :使能PC5输出,   FALSE:禁止PC5输出(默认)
#define           PWM10_POLS         FALSE            //PWM10极性控制,FALSE:同相输出(默认),TRUE :反相输出

#define           CCP_PWM11          TRUE             //PWM11输出控制,TRUE:使能PB5输出,    FALSE:禁止PB5输出(默认)
#define           PWM11_POLS         FALSE            //PWM11极性控制,FALSE:同相输出(默认),TRUE :反相输出
/******************************************PWM10_11设置***************************************/
///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////
/******************************************PWM12_13设置***************************************/
#define           PWM12_13_MODE      PWM_CPMT

//PWM12_13_MODE可选如下四种配置:
//                                   PWM_CPMT         :PWM互补式控制(默认)
//                                   UP_ARM           :非互补式上臂调制
//                                   DW_ARM           :非互补式下臂调制
//                                   SEL_cfg          :由如下定义“PWM12_13_SEL”控制

#define           PWM12_13_SEL       SEL_UP_DW_OFF

//当PWM12_13_MODE配置为SEL_cfg时,PWM12_13_SEL定义有效,可选如下四种配置:
//                                   SEL_UP_DW_OFF    :上/下臂输出都关闭(默认)
//                                   SEL_UP_OFF_DW_ON :上臂输出关闭/下臂输出导通
//                                   SEL_UP_ON_DW_OFF :上臂输出导通/下臂输出关闭
//                                   SEL_UPDW_Mw_OFF  :上/下臂输出都关闭（防止上/下臂同时导通）

#define           CCP_PWM12          TRUE             //PWM12输出控制,TRUE :使能PB4输出,    	FALSE:禁止PB4输出 (默认)
#define           PWM12_POLS         FALSE            //PWM12极性控制,FALSE:同相输出(默认),      TRUE :反相输出


#define           CCP_PWM13          TRUE             //PWM13输出控制,TRUE :使能PB3输出,   FALSE:禁止PB3输出(默认)
#define           PWM13_POLS         FALSE            //PWM13极性控制,FALSE:同相输出(默认),TRUE :反相输出
/******************************************PWM12_13设置***************************************/
///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////
/******************************************PWM14_15设置***************************************/
#define           PWM14_15_MODE      PWM_CPMT

//PWM14_15_MODE可选如下四种配置:
//                                   PWM_CPMT         :PWM互补式控制(默认)
//                                   UP_ARM           :非互补式上臂调制
//                                   DW_ARM           :非互补式下臂调制
//                                   SEL_cfg          :由如下定义“PWM14_15_SEL”控制

#define           PWM14_15_SEL       SEL_UP_DW_OFF

//当PWM14_15_MODE配置为SEL_cfg时,PWM14_15_SEL定义有效,可选如下四种配置:
//                                   SEL_UP_DW_OFF    :上/下臂输出都关闭(默认)
//                                   SEL_UP_OFF_DW_ON :上臂输出关闭/下臂输出 //如果使能PWM输出保护,PWM13保护后输出低电平; OUT_0:输出低电平,OUT_1:输出高电平导通
//                                   SEL_UP_ON_DW_OFF :上臂输出导通/下臂输出关闭
//                                   SEL_UPDW_Mw_OFF  :上/下臂输出都关闭（防止上/下臂同时导通）

#define           CCP_PWM14          TRUE             //PWM14输出控制,TRUE :使能PC2输出,   FALSE:禁止PC2输出(默认)
#define           PWM14_POLS         FALSE            //PWM14极性控制,FALSE:同相输出(默认),TRUE :反相输出
#define           PWM14_IO_CFG       PB2_OUT          //映射到PC2输出,PB2_OUT:PWM14映射到PB2输出,PC2_OUT:PWM14映射到PC2输出

#define           CCP_PWM15          TRUE             //PWM15输出控制,TRUE :使能PC4输出,   FALSE:禁止PC4输出(默认)
#define           PWM15_POLS         FALSE            //PWM15极性控制,FALSE:同相输出(默认),TRUE :反相输出
/******************************************PWM14_15设置***************************************/
///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////
/******************************************PWM死区控制****************************************/
#define           DTE_cfg            FALSE             //死区控制,TRUE:使能死区控制,FALSE:禁止死区控制(默认)

#define           DT_Fosc            FDT_Fsys_8

//死区时钟分频设置,可选如下配置
//                                   FDT_Fsys         //死区时钟为分频Fsys(默认)
//                                   FDT_Fsys_2       //死区时钟为分频Fsys/2
//                                   FDT_Fsys_4       //死区时钟为分频Fsys/4
//                                   FDT_Fsys_8       //死区时钟为分频Fsys/8

#define           DTD_cfg            16               //死区时间，设置范围为0 - 31,若该宏未定义或超出范围,则默认设置为16
/******************************************PWM死区控制****************************************/
///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////
/******************************************PWM故障保护****************************************/
#define           CMPOUT_Protect     FALSE            //CMP1_OUT产生从0变为1的故障信号后,禁止PWM输出; FALSE:禁用(默认),  TRUE:使能
#define           OPOUT_Protect      FALSE            //OP1_OUT产生从0变为1的故障信号后,禁止PWM输出;  FALSE:禁用(默认),  TRUE:使能
#define           IO_PC2_Protect     FALSE            //I/O(PC2)产生从0变为1的故障信号后,禁止PWM输出; FALSE:禁用(默认),  TRUE:使能

#define           Failure_Stop       FALSE            //当产生上述三个故障信号中的任意一个或多个信号后,PWM将被保护且停止输出

#define           PT11_OUT           OUT_0            //触发PWM11保护且停止输出后,其对应I/O需保持的状态: OUT_0:输出低电平(默认),OUT_1:输出高电平
#define           PT13_OUT           OUT_0            //触发PWM13保护且停止输出后,其对应I/O需保持的状态: OUT_0:输出低电平(默认),OUT_1:输出高电平
#define           PT15_OUT           OUT_0            //触发PWM15保护且停止输出后,其对应I/O需保持的状态: OUT_0:输出低电平(默认),OUT_1:输出高电平

#define           Relieve_Renew      FALSE            //当故障解信号除后,PWM恢复输出;      FALSE:禁用(默认), TRUE:使能
/******************************************PWM故障保护****************************************/
///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////
/******************************************二级防呆保护***************************************/
#define           DMISTK2_FC         FALSE            //二级防呆保护;                      FALSE:禁用(默认),  TRUE:使能
#define           DMISTK2_OUT        OUT_0            //二级防呆保护后PWM对应I/O保持的状态;OUT_0:保持低电平, OUT_1:保持高电平
/******************************************二级防呆保护***************************************/
///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////
/*****************************************PWM10触发AD转换*************************************/
#define           PWM10_EDGE_ADC     TRUE             //PWM10触发AD转换;      FALSE:禁用(默认),                   TRUE:使能
#define           EDGE_ADC_MODE      PWM10_LTOH_EDGE  //PWM沿触选择;PWM10_HTOL_EDGE:下降沿触发(默认),  PWM10_LTOH_EDGE: 上升沿触发
#define           EDGE_ADC_DELAY     128              //出发后延时进行AD采集的时间设置:0-256.若未设置,则默认为128
/*****************************************PWM10触发AD转换*************************************/
///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////
/**************************************将CCP_PWM切换到TIMER3**********************************/
#define           TIME3_PWM          FALSE            //将CCP_PWM切换到TIMER3              FALSE:禁用(默认), TRUE:使能
/**************************************将CCP_PWM切换到TIMER3**********************************/
///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////
/**********************************************************************************************PWM10_PWM15宏定义设置/
/**********************************************************************************************PWM10_PWM15宏定义设置/
/**********************************************************************************************PWM10_PWM15宏定义设置/
/**********************************************************************************************PWM10_PWM15宏定义设置/
/**********************************************************************************************PWM10_PWM15宏定义设置/



/**********************************************TIMER*****************************************/
#define           Timer2_ENABLE        1    //使能TIMER2
#define           Timer2_DISABLE       0    //禁用TIMER2

#define           Timer3_ENABLE        1    //使能TIMER3
#define           Timer3_DISABLE       0    //禁用TIMER3

#define           Y_FOSC_1             0    //TIMER3预分频为1
#define           Y_FOSC_4             1    //TIMER3预分频为4
#define           Y_FOSC_8             2    //TIMER3预分频为8
#define           Y_FOSC_16            3    //TIMER3预分频为16

#define           H_FOSC_1             0    //TIMER3后分频为1
#define           H_FOSC_2             1    //TIMER3后分频为2
#define           H_FOSC_3             2    //TIMER3后分频为3
#define           H_FOSC_4             3    //TIMER3后分频为4
#define           H_FOSC_5             4    //TIMER3后分频为5
#define           H_FOSC_6             5    //TIMER3后分频为6
#define           H_FOSC_7             6    //TIMER3后分频为7
#define           H_FOSC_8             7    //TIMER3后分频为8
#define           H_FOSC_9             8    //TIMER3后分频为9
#define           H_FOSC_10            9    //TIMER3后分频为10
#define           H_FOSC_11            10   //TIMER3后分频为11
#define           H_FOSC_12            11   //TIMER3后分频为12
#define           H_FOSC_13            12   //TIMER3后分频为13
#define           H_FOSC_14            13   //TIMER3后分频为14
#define           H_FOSC_15            14   //TIMER3后分频为15
#define           H_FOSC_16            15   //TIMER3后分频为16
/**********************************************TIMER*****************************************/

#define           AD_Vref_FVR           0   //设置ADC的参考电压为FVR
#define           AD_Vref_VCC           1   //设置ADC的参考电压为VCC
#define           AD_Vref_OP0_OUT       2   //设置ADC的参考电压为OP0_OUT
#define           AD_Vref_PB0           3   //设置ADC的参考电压为PB0口输入电压

#define           AD_CH0_PA3            0   //ADC通道 0（PA3）
#define           AD_CH1_PA2            1   //ADC通道 1（PA2）
#define           AD_CH2_PA1            2   //ADC通道 2（PA1）
#define           AD_CH3_PA0            3   //ADC通道 3（PA0）
#define           AD_CH4_PB0            4   //ADC通道 4（PB0）
#define           AD_CH5_PB1            5   //ADC通道 5（PB1）
#define           AD_CH6_PB5            6   //ADC通道 6（PB5）
#define           AD_CH7_PC1            7   //ADC通道 7（PC1）
#define           AD_CH8_PC0            8   //ADC通道 8（PC0）
#define           AD_CH9_PA5            9   //ADC通道 9（PA5）
#define           AD_CH10_BUFFER_UNIT  10   //ADC通道10（BUFFER_UNIT）
#define           AD_CH11_OP1OUT       11   //ADC通道11（OP1OUT）
#define           AD_CH12_OP0OUT       12   //ADC通道12（OP0OUT）
#define           AD_CH13_PB2          13   //ADC通道13（PB2）
#define           AD_CH14_DAC0OUT      14   //ADC通道14（DAC0OUT）
#define           AD_CH15_FVROUT       15   //ADC通道15（FVROUT）

#define           AD_0TAD               0   // 0TAD
#define           AD_2TAD               1   // 2TAD
#define           AD_4TAD               2   // 4TAD
#define           AD_6TAD               3   // 6TAD
#define           AD_8TAD               4   // 8TAD
#define           AD_10TAD              5   //10TAD
#define           AD_12TAD              6   //12TAD
#define           AD_14TAD              7   //14TAD

//配置字:  ADSP_OFF   ADSP_ON
#define           AD_FOSC_16_or_FOSC_2      0   //配置字ADSP_OFF时,ADC转换时钟为FOSC/16 ,ADSP_ON时,ADC转换时钟为FOSC/2
#define           AD_FOSC_32_or_FOSC_8      1   //配置字ADSP_OFF时,ADC转换时钟为FOSC/32 ,ADSP_ON时,ADC转换时钟为FOSC/8
#define           AD_FOSC_256_or_FOSC_32    2   //配置字ADSP_OFF时,ADC转换时钟为FOSC/256,ADSP_ON时,ADC转换时钟为FOSC/32
#define           AD_OSC_32K                3   //ADC转换时钟为内部32K_OSC
#define           AD_FOSC_32_or_FOSC_4      4   //配置字ADSP_OFF时,ADC转换时钟为FOSC/32 ,ADSP_ON时,ADC转换时钟为FOSC/4
#define           AD_FOSC_128_or_FOSC_16    5   //配置字ADSP_OFF时,ADC转换时钟为FOSC/128,ADSP_ON时,ADC转换时钟为FOSC/16
#define           AD_FOSC_512_or_FOSC_64    6   //配置字ADSP_OFF时,ADC转换时钟为FOSC/512,ADSP_ON时,ADC转换时钟为FOSC/64
#define           AD_OSC_1D024M             7   //ADC转换时钟为内部1.024M_OSC

#define           AD_CMP_MODE_0         0   //采集值大于ADCMP1[H:L]产生中断ADCMP1IF,小于ADCMP0[H:L]产生中断ADCMP0IF
#define           AD_CMP_MODE_1         1   //采集值小于ADCMP1[H:L]且大于ADCMP0[H:L]，产生中断ADCMP0IF

#define           AD_CMP_ACN1           0   //当ADC采样值与比较值符合条件1次时,触发比较中断标志ADCMP0IF
#define           AD_CMP_ACN2           1   //当ADC采样值与比较值符合条件2次时,触发比较中断标志ADCMP0IF
#define           AD_CMP_ACN4           2   //当ADC采样值与比较值符合条件4次时,触发比较中断标志ADCMP0IF
#define           AD_CMP_ACN8           3   //当ADC采样值与比较值符合条件8次时,触发比较中断标志ADCMP0IF

#define           AD_INT_ENABLE         1   //使能ADC中断
#define           AD_INT_DISABLE        0   //禁止ADC中断

/*********************************************中断设置**************************************/
#define           H_SysPri_INIT_EN       0  //使能高优先级中断
#define           H_SysPri_INIT_Dis      1  //禁用高优先级中断
#define           L_SysPri_INIT_EN       2  //使能低优先级中断
#define           L_SysPri_INIT_Dis      3  //禁用低优先级中断

#define           INT_OFF                0  //禁用外设中断
#define           H_Pri_INT              1  //外设使能高优先级中断
#define           L_Pri_INT              2  //外设使能低优先级中断
/*********************************************中断设置**************************************/

#define           PWM10_HTOL_EDGE        0
#define           PWM10_LTOH_EDGE        1

#define           FDT_Fsys               0
#define           FDT_Fsys_2             1
#define           FDT_Fsys_4             2
#define           FDT_Fsys_8             3

#define           PWM_CPMT               0
#define           UP_ARM                 1
#define           DW_ARM                 2

#define           SEL_cfg                3

#define           SEL_UP_DW_OFF          0
#define           SEL_UP_OFF_DW_ON       1
#define           SEL_UP_ON_DW_OFF       2
#define           SEL_UPDW_Mw_OFF        3

#define           OUT_1                  1
#define           OUT_0                  0

#define           PC2_OUT	             1
#define           PB2_OUT                0





/*******************************************************************************
* Description    : TIMER2初始化设置
* Input          : [T2_YF]:
*				    Y_FOSC_1 : TIMER2预分频为1
*				    Y_FOSC_4 : TIMER2预分频为4
*		  	        Y_FOSC_8 : TIMER2预分频为8
*				    Y_FOSC_16: TIMER2预分频为16
*
*				   [PWM_Freq]:0-65535 单位KHz
*                   !PWM周期 = FOSC/[PR2H:PR2L]/Timer2预分频值/Timer2后分频值
*
*                  [T2_HF]:
*				    H_FOSC_1 : TIMER2后分频为1
*				    H_FOSC_2 : TIMER2后分频为2
*			 	    H_FOSC_3 : TIMER2后分频为3
*			  	    H_FOSC_4 : TIMER2后分频为4
*				    H_FOSC_5 : TIMER2后分频为5
*				    H_FOSC_6 : TIMER2后分频为6
*				    H_FOSC_7 : TIMER2后分频为7
*				    H_FOSC_8 : TIMER2后分频为8
*				    H_FOSC_9 : TIMER2后分频为9
*				    H_FOSC_10: TIMER2后分频为10
*				    H_FOSC_11: TIMER2后分频为11
*				    H_FOSC_12: TIMER2后分频为12
*				    H_FOSC_13: TIMER2后分频为13
*				    H_FOSC_14: TIMER2后分频为14
*				    H_FOSC_15: TIMER2后分频为15
*				    H_FOSC_16: TIMER2后分频为16
*
*                  [T2_ON]:
*				    Timer2_ENABLE : 使能TIMER2
*				    Timer2_DISABLE: 禁用TIMER2
*
*                  [Pri_INT]:
*				    INT_OFF  : 禁用TIMER2中断
*				    H_Pri_INT: 使能TIMER2高优先级中断:
*				    L_Pri_INT: 使能TIMER2低优先级中断
*
* Return         : None.
* Note           : None.
*******************************************************************************/
void Timer2_Init(unsigned char T2_YF,unsigned long PWM_Freq,unsigned char T2_HF,unsigned char T2_ON,unsigned char Pri_INT);

/*******************************************************************************
* Description    : TIMER3初始化设置
* Input          : [T3_YF]:
*				    Y_FOSC_1 : TIMER3预分频为1
*				    Y_FOSC_4 : TIMER3预分频为4
*		  	        Y_FOSC_8 : TIMER3预分频为8
*				    Y_FOSC_16: TIMER3预分频为16
*
*				   [PWM_Freq]:0-65535 单位KHz
*                   !PWM周期 = FOSC/[PR2H:PR2L]/Timer2预分频值/Timer2后分频值
*
*                  [T3_HF]:
*				    H_FOSC_1 : TIMER3后分频为1
*				    H_FOSC_2 : TIMER3后分频为2
*			 	    H_FOSC_3 : TIMER3后分频为3
*			  	    H_FOSC_4 : TIMER3后分频为4
*				    H_FOSC_5 : TIMER3后分频为5
*				    H_FOSC_6 : TIMER3后分频为6
*				    H_FOSC_7 : TIMER3后分频为7
*				    H_FOSC_8 : TIMER3后分频为8
*				    H_FOSC_9 : TIMER3后分频为9
*				    H_FOSC_10: TIMER3后分频为10
*				    H_FOSC_11: TIMER3后分频为11
*				    H_FOSC_12: TIMER3后分频为12
*				    H_FOSC_13: TIMER3后分频为13
*				    H_FOSC_14: TIMER3后分频为14
*				    H_FOSC_15: TIMER3后分频为15
*				    H_FOSC_16: TIMER3后分频为16
*
*                  [T3_ON]:
*				    Timer3_ENABLE : 使能TIMER3
*				    Timer3_DISABLE: 禁用TIMER3
*
*                  [Pri_INT]:
*				    INT_OFF  : 禁用TIMER3中断
*				    H_Pri_INT: 使能TIMER3高优先级中断:
*				    L_Pri_INT: 使能TIMER3低优先级中断
*
* Return         : None.
* Note           : None.
*******************************************************************************/
void Timer3_Init(unsigned char T3_YF,unsigned long PWM_Freq,unsigned char T3_HF,unsigned char T3_ON,unsigned char Pri_INT);

/*******************************************************************************
* Description    : CCP_PWM10—PWM15初始化
* Input          : None.
* Return         : None.
* Note           : 请在本文件的"PWM10_PWM15宏定义设置区"对需要的功能进行设
*                  置，然后在执行该初始化程序
*                  PWM10_PC5、PWM12_PB2/PB4、PWM14_PC2
*                  PWM11_PB5、PWM13_PB3    、PWM15_PC4
*******************************************************************************/
void CCP_PWM_Init(void);

/*******************************************************************************
* Description    : Timer2_PWM占空比设置
* Input          : Timer2_PWM的占空比 （0%-99%）
* Return         : None.
* Note           : 该函数可以设置Timer1_PWM的占空比
*                  *占空比=[PR2H:PR2L]*(Duty/100)
*******************************************************************************/
void Config_PWM_Duty(unsigned short Duty);

//==============================================================================================
// ----Function: Config_ADC
// --Parameters:
//【Channel】：AD转换通道设置（可选如下）
//
//            AD_CH0_PA3： ADC通道 0（PA3）
//            AD_CH1_PA2： ADC通道 1（PA2）
//            AD_CH2_PA1： ADC通道 2（PA1）
//            AD_CH3_PA0： ADC通道 3（PA0）
//            AD_CH4_PB0： ADC通道 4（PB0）
//            AD_CH5_PB1： ADC通道 5（PB1）
//            AD_CH6_PB5： ADC通道 6（PB5）
//            AD_CH7_PC1： ADC通道 7（PC1）
//            AD_CH8_PC0： ADC通道 8（PC0）
//            AD_CH9_PA5： ADC通道 9（PA5）
//   AD_CH10_BUFFER_UNIT： ADC通道10（BUFFER_UNIT）
//        AD_CH11_OP1OUT： ADC通道11（OP1OUT）
//        AD_CH12_OP0OUT： ADC通道12（OP0OUT）
//           AD_CH13_PB2： ADC通道13（PB2）
//       AD_CH14_DAC0OUT： ADC通道14（DAC0OUT）
//        AD_CH15_FVROUT： ADC通道15（FVROUT）
//
//【Vref_Volt】：ADC参考电压选择（可选如下）
//
//            AD_Vref_FVR：参考电压为FVR
//            AD_Vref_VCC：参考电压为VCC
//        AD_Vref_OP0_OUT：参考电压为OP0_OUT
//            AD_Vref_PB0：参考电压为PB0口输入电压
//
//【AD_ACQT】：ADC采集时间选择（可选如下）
//
//                AD_0TAD： 0 TAD
//                AD_2TAD： 2 TAD
//                AD_4TAD： 4 TAD
//                AD_6TAD： 6 TAD
//                AD_8TAD： 8 TAD
//               AD_10TAD：10 TAD
//               AD_12TAD：12 TAD
//               AD_14TAD：14 TAD
//
//【AD_CS】：ADC转换时钟选择（可选如下）
//
//   AD_FOSC_16_or_FOSC_2：FOSC/16(ADSP=0) ，FOSC/2(ADSP=1)
//   AD_FOSC_32_or_FOSC_8：FOSC/32 (ADSP=0)，FOSC/8(ADSP=1)
// AD_FOSC_256_or_FOSC_32：FOSC/256(ADSP=0)，FOSC/32(ADSP=1)
//             AD_OSC_32K：内部 32K OSC
//   AD_FOSC_32_or_FOSC_4：FOSC/32(ADSP=0) ，FOSC/4(ADSP=1)
// AD_FOSC_128_or_FOSC_16：FOSC/128(ADSP=0)，FOSC/16(ADSP=1)
// AD_FOSC_512_or_FOSC_64：FOSC/512(ADSP=0)，FOSC/64(ADSP=1)
//          AD_OSC_1D024M：内部 1.024M_OSC
//
//【AD_Pri_INT】：AD中断设置
//
//				  INT_OFF：禁用AD中断
//				H_Pri_INT：使能AD高优先级中断:
//			    L_Pri_INT：使能AD低优先级中断
//
// -----Returns: None
//---------Note: 该函数可设置AD转换的通道、参考电压、采集时间、转换时钟并使能ADC模块
//==============================================================================================
void Config_ADC(unsigned char Channel,unsigned char Vref_Volt,unsigned char AD_ACQT,unsigned char AD_CS,unsigned char AD_Pri_INT);

//==============================================================================================
// ----Function: Config_AUTO_ADC
// --Parameters:
//【Channel】：AD转换通道设置（可选如下）
//
//            AD_CH0_PA3： ADC通道 0（PA3）
//            AD_CH1_PA2： ADC通道 1（PA2）
//            AD_CH2_PA1： ADC通道 2（PA1）
//            AD_CH3_PA0： ADC通道 3（PA0）
//            AD_CH4_PB0： ADC通道 4（PB0）
//            AD_CH5_PB1： ADC通道 5（PB1）
//            AD_CH6_PB5： ADC通道 6（PB5）
//            AD_CH7_PC1： ADC通道 7（PC1）
//            AD_CH8_PC0： ADC通道 8（PC0）
//            AD_CH9_PA5： ADC通道 9（PA5）
//   AD_CH10_BUFFER_UNIT： ADC通道10（BUFFER_UNIT）
//        AD_CH11_OP1OUT： ADC通道11（OP1OUT）
//        AD_CH12_OP0OUT： ADC通道12（OP0OUT）
//           AD_CH13_PB2： ADC通道13（PB2）
//       AD_CH14_DAC0OUT： ADC通道14（DAC0OUT）
//        AD_CH15_FVROUT： ADC通道15（FVROUT）
//
//【Vref_Volt】：ADC参考电压选择（可选如下）
//
//           AD_Vref_FVR：参考电压为FVR
//           AD_Vref_VCC：参考电压为VCC
//       AD_Vref_OP0_OUT：参考电压为OP0_OUT
//           AD_Vref_PB0：参考电压为PB0口输入电压
//
//【TIM1_Dly】：定时自动采集时间设置
//              设置范围：0-2048
//              单位:毫秒(ms)
//
//【AD_ACQT】 ：开始采集后延迟时间设置
//              计算公式:T = ACQT[6:0]*2*当前的AD时钟
//              设置范围：0-127
//
//【AD_CS】：ADC转换时钟选择（可选如下）
//
//   AD_FOSC_16_or_FOSC_2：FOSC/16(ADSP=0) ，FOSC/2(ADSP=1)
//   AD_FOSC_32_or_FOSC_8：FOSC/32 (ADSP=0)，FOSC/8(ADSP=1)
// AD_FOSC_256_or_FOSC_32：FOSC/256(ADSP=0)，FOSC/32(ADSP=1)
//             AD_OSC_32K：内部 32K OSC
//   AD_FOSC_32_or_FOSC_4：FOSC/32(ADSP=0) ，FOSC/4(ADSP=1)
// AD_FOSC_128_or_FOSC_16：FOSC/128(ADSP=0)，FOSC/16(ADSP=1)
// AD_FOSC_512_or_FOSC_64：FOSC/512(ADSP=0)，FOSC/64(ADSP=1)
//            AD_OSC_256K：内部 256K OSC
//
//【AD_Pri_INT】：AD中断设置
//
//				  INT_OFF：禁用AD中断
//				H_Pri_INT：使能AD高优先级中断:
//			    L_Pri_INT：使能AD低优先级中断
//
// -----Returns: None
//---------Note: 该函数可设置AD定时自动采集功能，以及相关的采集通道、参考电压、采集时间和转换时钟,并使能ADC模块
//               *设置自动采集延迟时间，则AD采集总延迟时间=TIMER1定时时间+ACQT[6:0]延时时间

//==============================================================================================
void Config_TIMER1_AUTO_ADC(unsigned char Channel,unsigned char Vref_Volt,unsigned int TIM1_Dly,unsigned char AD_ACQT,unsigned char AD_CS,unsigned char AD_Pri_INT);

//==============================================================================================
// ----Function: Config_ADCMP_Interrupt
// --Parameters:
//【ADCMP_MODE】:ADC比较模式设置
//
// AD_CMP_MODE_0：ADC比较模式0,即“采集值大于ADCMP1[H:L]产生中断ADCMP1IF,小于ADCMP0[H:L]产生中断ADCMP0IF”;
// AD_CMP_MODE_1：ADC比较模式1,即“采集值小于ADCMP1[H:L]且大于ADCMP0[H:L]，产生中断ADCMP0IF”;
//
//【ADCMP_ACN】:当ADC采样值符合条件达到指定次数时,触发比较中断标志ADCMP0IF
//
//   AD_CMP_ACN1：当ADC采样值与比较值符合条件1次时,触发比较中断标志ADCMP0IF
//   AD_CMP_ACN2：当ADC采样值与比较值符合条件2次时,触发比较中断标志ADCMP0IF
//   AD_CMP_ACN4：当ADC采样值与比较值符合条件4次时,触发比较中断标志ADCMP0IF
//   AD_CMP_ACN8：当ADC采样值与比较值符合条件8次时,触发比较中断标志ADCMP0IF
//
//【Value_1】:ADC比较器的比较值(设置范围0-4095),详见手册比较模式设置说明
//【Value_0】:ADC比较器的比较值(设置范围0-4095),详见手册比较模式设置说明
//
//【AD_Pri_INT】：AD中断设置
//
//				  INT_OFF：禁用AD中断
//				H_Pri_INT：使能AD高优先级中断:
//			    L_Pri_INT：使能AD低优先级中断
//
// -----Returns: None
//---------Note: 该函数可设置AD转换的比较中断功能

//==============================================================================================
void Config_ADCMP_Interrupt(unsigned char ADCMP_MODE,unsigned char ADCMP_ACN,unsigned short Value_1,unsigned short Value_0,unsigned char AD_Pri_INT);

//==============================================================================================
// ----Function: 启动AD转换
// --Parameters: None
// -----Returns: None
//---------Note: 每次转换前需调用该函数以启动AD转换
//==============================================================================================
void ADC_Start(void);

//==============================================================================================
// ----Function: ADC_SampleFilter
// --Parameters: None
// -----Returns: None
//---------Note: 该函数用于AD转转换的结果获取
//               *该函数采用了Time_OUT方式防止AD转换因为静电等原因导致的运行异常，一旦出现这种情况则重新启动AD转换；
//               *该函数使用了平滑滤波算法，以保证输出的数据稳定，该算法不一定适用于所有情况，请更具实际情况选择对应的算法；
//==============================================================================================
unsigned short ADC_SampleFilter(void);

/*******************************************************************************
* Description    : 设置系统优先级总中断
* Input          : [INT_cfg]:
*                            H_SysPri_INIT_EN : 使能高优先级中断
*                            H_SysPri_INIT_Dis: 禁用高优先级中断
*                            L_SysPri_INIT_EN : 使能低优先级中断
*                            L_SysPri_INIT_Dis: 禁用低优先级中断
* Return         : None.
* Note           : None.
*******************************************************************************/
void System_INIT_Config(unsigned char INT_cfg);

#endif
