/*******************************************************************************
* Device      : AD18F02x
* Author      : XAD Application Team
* Version     : V0.0.1
* Date        : 20201201
* Description : 系统函数，及通用定义
********************************************************************************/

/********************************INCLUDES*************************************/

#include "Common.h"

/*******************************************************************************
* Description    : GPIO初始化
* Input          : None.
* Return         : None.
* Note           : None.
*******************************************************************************/

void GPIO_Init()
{
/*********************************************************
*	GPIO部分共有以下几个寄存器分别为：
*
*	TRISA/B/Cn：1-输入状态，port写无效()	默认1
*				0-输出状态
*	PORTA/B/Cn：I/O口数据位（ n=7-0）		默认0
*	PA/B/CPDn : 1-下拉无效 0-下拉有效		默认1
*	PA/B/CPUn : 1-上拉无效 0-上拉有效		默认1
*	PA/B/CODn : 1-使能开漏 0-普通推挽		默认0
*	PINA/B/C  :	1-读入为1  0-读入IO口为0
*	ANASEL0/1/2 :	1-模拟输出打开关闭	0-模拟输出关闭	默认0
*	SMTVA/B/C	：1-0.3VDD/0.7VDD,0-0.2VDD/0.4VDD 默认1
*
*  以上寄存器既可整体赋值，也可按位赋值；
***********************************************************/


//需关闭默认的上拉和下拉电阻以免影响模拟部分功能
	PAPU = 0XFE;	//PA0_RX，PA1_TX
	PBPU = 0XFF;
	PCPU = 0XFF;

	PAPD = 0XFF;
	PBPD = 0XFF;
	PCPD = 0XFF;

	PAOD = 0X00;
	PBOD = 0X00;
	PCOD = 0X00;

	TRISA=0X01;		//PA0_RX，PA1_TX
	TRISB=0X00;
	TRISC=0X00;

	PORTA=0X03;		//PA0_RX，PA1_TX
	PORTB=0X00;
	PORTC=0X00;
}
